/* A Bison parser, made from parser/maria.y
   by GNU bison 1.32.  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse pnparse
#define yylex pnlex
#define yyerror pnerror
#define yylval pnlval
#define yychar pnchar
#define yydebug pndebug
#define yynerrs pnnerrs
# define	UNTIL	257
# define	RELEASE	258
# define	IMPL	259
# define	EQUIV	260
# define	OR	261
# define	XOR	262
# define	AND	263
# define	FINALLY	264
# define	GLOBALLY	265
# define	NEXT	266
# define	NE	267
# define	EQ	268
# define	GE	269
# define	LE	270
# define	ROL	271
# define	ROR	272
# define	IS	273
# define	CARDINALITY	274
# define	MIN	275
# define	MAX	276
# define	MAP	277
# define	EQUALS	278
# define	SUBSET	279
# define	MINUS	280
# define	UNION	281
# define	INTERSECT	282
# define	ATOM	283
# define	NUMBER	284
# define	CHARACTER	285
# define	NAME	286
# define	TRUE_	287
# define	FALSE_	288
# define	UNDEFINED	289
# define	FATAL	290
# define	TYPEDEF	291
# define	CONST	292
# define	PLACE	293
# define	TRANS	294
# define	IN	295
# define	OUT	296
# define	GATE	297
# define	REJECT_	298
# define	DEADLOCK	299
# define	ENUM	300
# define	ID	301
# define	STRUCT	302
# define	QUEUE	303
# define	STACK	304
# define	RANGE	305
# define	EMPTY	306
# define	SFAIR	307
# define	WFAIR	308
# define	HIDE	309
# define	PROP	310

#line 3 "parser/maria.y"

#ifndef __WIN32
# include <alloca.h>
#endif // !__WIN32

#include "util.h"
#include "Printer.h"
#include "VariableStackMap.h"

#include "allExpressions.h"
#include "ExpressionSet.h"
#include "Constraint.h"
#include "Range.h"

#include "Arc.h"
#include "Transition.h"
#include "Place.h"
#include "Net.h"
#include "VariableDefinition.h"
#include "VariableSet.h"
#include "Function.h"

#include "Quantifier.h"

#include "TransitionQualifier.h"

#include "allTypes.h"
#include "allValues.h"
#include "Valuation.h"
#include "Substitution.h"

# include <set>
# include <map>
# include <list>
# include <stack>

# ifndef NDEBUG
#  define ASSERT1(x) x
# else
#  define ASSERT1(x)
# endif

  /** @file maria.y
   * Parser for the modelling language
   */

  /** warning flag (true=print warnings) */
  extern bool pnwarnings;
  /** number of errors encountered */
  extern unsigned pnerrors;
  /** Maximum index type size of arrays */
  card_t maxIndex = 256;
  /** Maximum range size of quantifications */
  card_t maxRange = 256;

  /** lexical analyzer function
   * @return		a terminal symbol, and set yylval to its semantic value
   */
  extern int pnlex ();

  /** Check the validity of an identifier
   * @param name	name of the identifier
   * @param type	type of the identifier
   * @param msg		error message
   */
  extern void checkName (const char* name, unsigned type, const char* msg);
  /** validity check codes for checkName */
  enum checkNameType {
    ckPlace = 0, ckTrans, ckType, ckEnum, ckComp,
    ckFunc, ckParam, ckVar, ckIter
  };

  /** The Petri Net */
  extern class Net* net;
# define theNet (*net)
  /** The printer object */
  extern class Printer thePrinter;
  /** Parameters of the function that is currently being processed */
  static class VariableDefinition** currentParameters = NULL;
  /** Arity of the function that is currently being processed */
  static unsigned currentArity = 0;
  /** Function being invoked */
  static std::stack< class Function*, std::list<class Function*> >
    functionStack;
  /** The place that is currently being processed */
  class Place* currentPlace = NULL;
  /** The transition that is currently being processed */
  class Transition* currentTransition = NULL;
  /** The context transition (not being processed) */
  static class Transition* currentContextTransition = NULL;
  /** The type definition that is currently being processed */
  static const class Type* currentType = NULL;
  /** The context type of currentType (StructType or VectorType or NULL) */
  static const class Type* currentContextType = NULL;
  /** Struct or vector component number currently being parsed */
  static card_t currentComponent;
  /** Type context */
  struct TypeContext
  {
    /** Context type (@see currentContextType), may be NULL */
    const class Type* context;
    /** Component type (@see currentContext) */
    const class Type* component;
    /** Number of current component (@see currentComponent)
     * , meaningless if context==NULL */
    card_t numComponent;
  };
  /** Stack of types, used e.g. when parsing quantifier conditions */
  static std::stack< struct TypeContext, std::list<struct TypeContext> >
    typeStack;
  /** Flag: is an output arc being parsed? */
  static bool isOutputArc = false;
  /** Flag: has a number been successfully parsed? */
  static bool numberParsed = false;

  /** Flag: has an empty list component been parsed? */
  static bool emptyParsed = false;

  /** Flag: is a strong fairness constraint being parsed? */
  static bool isFairnessStrong = false;

  typedef std::pair<const class Type*,card_t> StructLevel;
  /** Stack for parsing structs and vectors */
  static std::stack< StructLevel, std::list<StructLevel> > structLevels;

  /** check the validity of an iterator variable name
   * @param name	name of the identifier variable
   */
  static void checkIterator (const char* name);

  /** Make a copy of a type if it is not an unnamed user type
   * @param type	the type to be copied
   * @return		type or a copy of it
   */
  static class Type* copyType (class Type* type);

  /** Delete the type definition if it is an unnamed user type
   * @param type	the type to be deleted
   */
  static void deleteType (class Type* type);

  /** Display a type name in an error message
   * @param type	type to be displayed
   */
  static void printType (const class Type& type);

  /** Push the type context on structLevels
   * @param type	new type context
   */
  static void pushTypeContext (const class Type* type);
  /** Restore the type context from structLevels */
  static void popTypeContext ();

  /** Get the parameter of the currently parsed function by name
   * @param name	name of the parameter
   * @return		the corresponding VariableDefinition, or NULL
   */
  static const class VariableDefinition* getParameter (char* name);

  /** Add a parameter to the function definition being parsed
   * @param type	type of the parameter
   * @param name	name of the parameter
   */
  static void addParameter (const class Type* type, char* name);

  /** Get a Function by name
   * @param name	the function name
   * @return		a Function object
   */
  static class Function* getFunction (const char* name);

  /** Get a zero-arity Function by name
   * @param name	the function name
   * @return		a Function object
   */
  static class Function* getConstantFunction (const char* name);
  
  /** Get a Constant by name
   * @param name	the constant name
   * @return		a Constant object
   */
  static const class Constant* getConstant (const char* name);

  /** Get a VariableDefinition by name
   * @param name	the variable name
   * @return		a VariableDefinition object
   */
  static const class VariableDefinition* getVariable (char* name);

  /** Resolve a name to a constant or variable
   * @param name	the name
   * @return		the resolved expression, or NULL
   */
  static class Expression* resolveName (char* name);

  /** Ensure that the formula is a set-valued expression
   * @param expr	formula to be checked
   * @param type	expected type of the formula
   * @return		expr, pointer to a Marking object, or NULL
   */
  static class Expression* ensureSet (class Expression* expr,
				      const class Type* type = 0);

  /** Ensure that the formula is a marking expression, converting if needed
   * @param expr	formula to be checked
   * @param type	expected type of the expression
   * @param temporal	flag: allow expr to be temporal
   * @return		pointer to a Marking object, or NULL
   */
  static class Marking* ensureMarking (class Expression* expr,
				       const class Type* type,
				       bool temporal = false);

  /** Ensure that the formula is not a marking expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* noMarking (class Expression* expr);

  /** Ensure that the formula is a basic expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureExpr (class Expression* expr);

  /** Ensure that the formula is a boolean expression
   * @param expr	formula to be checked
   * @param undefined	flag: allow the formula to be Undefined
   * @return		expr or NULL
   */
  static class Expression* ensureBool (class Expression* expr,
				       bool undefined = false);

  /** Ensure that the formula is a signed integer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureInt (class Expression* expr);

  /** Ensure that the formula is an unsigned integer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureCard (class Expression* expr);

  /** Ensure that the formula is a signed or unsigned integer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureIntCard (class Expression* expr);

  /** Ensure that the formula is a buffer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureBuffer (class Expression* expr);

  /** Ensure that the formula is a basic expression of ordered type
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureOrdered (class Expression* expr);

  /** Add an enumeration constant to an enumerated type, ensuring uniqueness.
   * @param e		the enumeration type
   * @param name	name of the constant
   */
  static void addEnumeration (class EnumType* e, char* name);

  /** Add an enumeration constant to an enumerated type, ensuring uniqueness.
   * @param e		the enumeration type
   * @param name	name of the constant
   * @param value	value of the constant
   */
  static void addEnumeration (class EnumType* e, char* name, card_t value);

  /** Ensure that the formula is a constant literal
   * @param expr	formula to be checked
   * @param type	type of the constant expected
   * @return		the value of expr or NULL
   */
  static class Value* ensureConstant (class Expression* expr,
				      const class Type* type);

  /** Convert an integer to an enumeration value if possible
   * @param type	type of the enumeration value
   * @param value	numerical value to be converted to the enumeration type
   * @return		a constant having the enumeration value or NULL
   */
  static class Expression* enumValue (const class EnumType& type,
				      card_t value);

  /** Ensure that a named component matches a struct being parsed
   * @param name	name of the component
   * @param expr	initialization expression for the component
   * @return		expr or NULL
   */
  static class Expression* namedComponent (char* name, class Expression* expr);

  /** Begin parsing a non-determinism expression
   * @param type	type of the expression
   * @param hidden	flag: hide the variable from transition instances
   * @param name	name of the non-deterministic variable (optional)
   */
  static void beginAny (class Type*& type, char* name, bool hidden);

  /** End parsing a non-determinisim expression
   * @param type	type of the expression
   * @param name	name of the non-deterministic variable (optional)
   * @param condition	quantification condition (optional)
   * @return		a Variable expression for the variable, or NULL
   */
  static class Variable* endAny (const class Type* type, char* name,
				 class Expression* condition);

  /** Begin parsing a quantifier expression
   * @param name	name of the quantifier variable
   * @param type	type of the quantifier variable
   */
  static void beginQuantifier (char* name, const class Type* type);

  /** Continue parsing a quantifier expression
   *  (after parsing an optional condition)
   * @param type	type of the quantifier variable
   */
  static void continueQuantifier (ASSERT1 (const class Type* type));

  /** End parsing a quantifier expression
   * @param name	name of the quantifier variable
   * @param type	type of the quantifier variable
   * @param condition	quantification condition (optional)
   * @param kind	quantification kind (1=sum, 2=forall, 3=exists)
   * @param expr	expression
   * @param temporal	flag: allow expr to be temporal
   * @return		expr augmented with the quantifier, or NULL if failed
   */
  static class Expression* endQuantifier (char* name, const class Type* type,
					  class Expression* condition,
					  unsigned kind,
					  class Expression* expr,
					  bool temporal);

  /** Declare a quantified variable
   * @param prefix	prefix of the quantified variable
   * @param quant	name of the quantifier variable
   * @param pred	flag: use a predecessor value of the quantifier
   * @return		a quantified variable, or NULL if failed
   */
  static class Expression* quantifierVariable (char* prefix,
					       char* quant,
					       bool pred);

  /** Try to make expr compatible with type if expr is a Constant
   * @param expr	expression to be made compatible
   * @param type	type to be made compatible with
   * @param casting	flag: typecasting in progress (suppress a warning)
   * @return		true if expr is not a Constant or
   *			if the conversion succeeded
   */
  static bool makeCompatible (class Expression*& expr,
			      const class Type& type,
			      bool casting = false);

  /** Determine whether an expression is compatible with a type
   * @param expr	expression to be checked
   * @param type	the type
   * @return		true if the expression is compatible with the type
   */
  static bool isCompatible (class Expression*& expr,
			    const class Type* type);

  /** Determine whether an expression is compatible with
   * the struct component being parsed
   * @param expr	expression to be checked
   * @param s		the struct whose current component is considered
   * @return		true if the expression is compatible with the struct
   */
  static bool isCompatible (class Expression*& expr,
			    const class StructExpression& s);

  /** Ensure that the type is ordered
   * @param type	type to be checked
   * @return		true if the type is ordered
   */
  static bool isOrdered (const class Type& type);

  /** Check a valuation
   * @param v		valuation to be checked
   * @return		true if the valuation is OK
   */
  static bool check (const class Valuation& v);

  /** Perform constant folding
   * @param expr	expression to be folded
   * @return		expr or a new Constant, or NULL in case of error
   */
  static class Expression* fold (class Expression* expr);

  /** Define a function
   * @param type	type of the function
   * @param name	name of the function
   * @param expr	body of the function
   */
  static void defun (const class Type* type,
		     char* name,
		     class Expression* expr);

  /** Create a RelopExpression or optimize it
   * @param equal	flag: equality comparison (instead of less-than)
   * @param left	left-hand-side of RelopExpression
   * @param right	right-hand-side of RelopExpression
   * @return		RelopExpression or a Boolean constant
   */
  static class Expression* newRelopExpression (bool equal,
					       class Expression* left,
					       class Expression* right);

  /** Create a BinopExpression
   * @param op		operator
   * @param left	left-hand-side of BinopExpression
   * @param right	right-hand-side of BinopExpression
   * @return		BinopExpression
   */
  static class Expression* newBinopExpression (enum BinopExpression::Op op,
					       class Expression* left,
					       class Expression* right);

  /** Create a NotExpression or optimize it
   * @param expr	an expression
   * @return		a negation of the expression
   */
  static class Expression* newNotExpression (class Expression* expr);

  /** Create a BooleanBinop or optimize it
   * @param conj	flag: conjunction (instead of disjunction)
   * @param left	left-hand-side of BooleanBinop
   * @param right	right-hand-side of BooleanBinop
   * @return		left, right, Boolean constant, or a BooleanBinop
   */
  static class Expression* newBooleanBinop (bool conj,
					    class Expression* left,
					    class Expression* right);

  /** Create a SetExpression or optimize it
   * @param op		operator
   * @param left	left-hand-side of SetExpression
   * @param right	right-hand-side of SetExpression
   */
  static class Expression* newSetExpression (enum SetExpression::Op op,
					     class Expression* left,
					     class Expression* right);
  /** Create a CardinalityExpression or optimize it
   * @param op		operator
   * @param expr	the multi-set expression
   */
  static class Expression* newCardinalityExpression
    (enum CardinalityExpression::Op op,
     class Expression* expr);

  /** Create a BufferUnop from a buffer expression
   * @param op		operator
   * @param expr	the buffer expression
   * @return		a BufferUnop object, or NULL
   */
  static class Expression* newBufferUnop (enum BufferUnop::Op op,
					  class Expression* expr);

  /** Variable stack map to be used with variable scoping */
  static class VariableStackMap currentVariables;

  /** Set of subexpressions for common subexpression elimination */
  static class ExpressionSet currentExpressions;

  /** Eliminate common subexpressions
   * @param expr	expression to be searched in currentExpressions
   * @return		expr or an equivalent expression
   */
  inline static class Expression* CSE (class Expression* expr) {
    return expr ? currentExpressions.insert (expr) : NULL;
  }

  /**
   * generic compiler warning reporting function
   * @param s		warning message
   */
  extern void pnwarn (const char* s);

  /**
   * generic parser error reporting function
   * @param s		error message
   */
  extern void pnerror (const char* s);

#line 497 "parser/maria.y"
#ifndef YYSTYPE
typedef union{
  card_t i;
  bool flag;
  char_t c;
  char* s;
  class Expression* expr;
  class ExpressionList* exprList;
  class Transition* trans;
  class Place* place;
  class Marking* marking;
  class Type* type;
  class ComponentList* componentList;
  class Value* value;
  class Range* range;
  class Constraint* constraint;
} yystype;
# define YYSTYPE yystype
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		446
#define	YYFLAG		-32768
#define	YYNTBASE	82

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 310 ? yytranslate[x] : 182)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    34,     2,    31,     2,    30,    17,     2,
      47,    79,    28,    26,    81,    27,    45,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,    75,
      22,    80,    23,     3,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    46,     2,    78,    16,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    76,    15,    77,    33,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    18,    19,    20,
      21,    24,    25,    32,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     3,     5,     8,    11,    15,    17,    19,
      21,    23,    25,    27,    29,    33,    35,    37,    40,    43,
      48,    53,    58,    63,    65,    66,    70,    75,    81,    86,
      90,    94,    96,    98,   101,   105,   108,   110,   112,   114,
     116,   118,   120,   121,   123,   124,   126,   128,   129,   131,
     132,   134,   138,   142,   148,   150,   152,   154,   157,   162,
     165,   166,   168,   170,   172,   173,   179,   180,   188,   191,
     196,   199,   200,   201,   202,   206,   207,   210,   211,   219,
     221,   222,   226,   227,   230,   231,   237,   240,   241,   246,
     247,   252,   253,   258,   259,   264,   265,   270,   271,   276,
     277,   279,   283,   286,   290,   291,   298,   301,   302,   305,
     309,   311,   315,   316,   319,   320,   326,   327,   330,   333,
     335,   338,   341,   343,   346,   349,   351,   355,   357,   360,
     363,   368,   369,   373,   375,   377,   380,   383,   385,   389,
     391,   393,   395,   399,   401,   402,   407,   408,   412,   413,
     415,   418,   422,   424,   428,   429,   431,   433,   435,   437,
     439,   441,   443,   446,   447,   453,   455,   457,   460,   462,
     464,   466,   468,   470,   471,   476,   477,   482,   483,   488,
     492,   495,   496,   501,   502,   508,   512,   516,   520,   524,
     528,   532,   536,   540,   544,   548,   552,   555,   558,   561,
     564,   567,   570,   573,   576,   579,   582,   586,   590,   594,
     598,   602,   606,   607,   608,   619,   620,   628,   632,   633,
     639,   642,   646,   650,   654,   658,   662,   665,   668,   671,
     675,   679,   681,   685,   689,   693,   697,   701,   704,   707,
     710,   714,   718,   719,   720,   728,   732,   736,   737,   745,
     746,   754,   755,   765,   766,   767,   770,   771,   776,   779,
     781,   785,   786,   787,   795,   796,   801,   803,   807,   810,
     814,   818,   822,   826
};
static const short yyrhs[] =
{
      -1,    83,     0,    75,     0,    83,    75,     0,    84,    75,
       0,    83,    84,    75,     0,    85,     0,   107,     0,   114,
       0,   119,     0,   143,     0,   141,     0,   142,     0,    55,
      87,    98,     0,    67,     0,    68,     0,    86,    67,     0,
      86,    68,     0,    64,    76,   101,    77,     0,    65,    46,
      95,    78,     0,    66,    76,   104,    77,     0,    42,    76,
     104,    77,     0,    94,     0,     0,    87,    88,    89,     0,
      87,    46,    87,    78,     0,    87,    46,    86,    95,    78,
       0,    87,    46,    48,    78,     0,    47,    90,    79,     0,
      90,   102,    91,     0,    91,     0,    93,     0,    69,    93,
       0,    92,    69,    92,     0,    92,    69,     0,   156,     0,
     155,     0,    96,     0,   156,     0,    50,     0,     1,     0,
       0,    96,     0,     0,    96,     0,    96,     0,     0,    80,
       0,     0,    99,     0,   101,   102,    99,     0,    99,   100,
      95,     0,   101,   102,    99,   100,    95,     0,    75,     0,
      81,     0,    98,     0,    87,   103,     0,   104,   102,    87,
     103,     0,   104,   102,     0,     0,    14,     0,    80,     0,
      98,     0,     0,    94,   106,   105,   108,   158,     0,     0,
      94,   106,    47,   110,    79,   109,   158,     0,    94,    98,
       0,   110,   102,    94,    98,     0,   110,   102,     0,     0,
       0,     0,   111,   112,    89,     0,     0,   113,    56,     0,
       0,   137,    96,   111,    87,   113,   115,   117,     0,    98,
       0,     0,   117,     4,   149,     0,     0,   118,    34,     0,
       0,   138,    98,   118,   120,   122,     0,   138,    98,     0,
       0,   122,    76,   128,    77,     0,     0,   122,    59,   123,
     132,     0,     0,   122,    60,   124,   132,     0,     0,   122,
      61,   125,   139,     0,     0,   122,   145,   126,   158,     0,
       0,   122,    73,   127,   156,     0,     0,   129,     0,   128,
     102,   129,     0,   128,   102,     0,   131,    94,    98,     0,
       0,   131,    94,    96,    34,   130,   152,     0,   131,   107,
       0,     0,   131,    73,     0,    76,   133,    77,     0,   134,
       0,   133,    75,   134,     0,     0,   136,     1,     0,     0,
     136,   116,     4,   135,   149,     0,     0,   136,    57,     0,
     136,    58,     0,    57,     0,   137,    57,     0,   137,    58,
       0,    58,     0,   138,    58,     0,   138,    57,     0,   140,
       0,   139,    81,   140,     0,   156,     0,    62,   156,     0,
      63,   156,     0,    74,    98,     4,   156,     0,     0,   145,
     144,   146,     0,    72,     0,    71,     0,   145,    72,     0,
     145,    71,     0,   147,     0,   146,    81,   147,     0,   178,
       0,   158,     0,   148,     0,   149,    81,   148,     0,   158,
       0,     0,   150,    81,   151,   148,     0,     0,    47,   155,
      79,     0,     0,   156,     0,    50,     4,     0,    50,     4,
     156,     0,   153,     0,   154,    81,   153,     0,     0,   156,
       0,   158,     0,     1,     0,     4,     0,     9,     0,    11,
       0,     1,     0,    96,    14,     0,     0,    96,    47,   159,
     174,    79,     0,    51,     0,    52,     0,   137,   116,     0,
      50,     0,    48,     0,    49,     0,    53,     0,    54,     0,
       0,    76,   160,   154,    77,     0,     0,    32,    94,   161,
     158,     0,     0,    96,    80,   162,   158,     0,   158,    32,
      98,     0,    44,   158,     0,     0,    94,    34,   163,   152,
       0,     0,    94,    96,    34,   164,   152,     0,   158,    22,
     158,     0,   158,    19,   158,     0,   158,    23,   158,     0,
     158,    20,   158,     0,   158,    18,   158,     0,   158,    21,
     158,     0,   158,    26,   158,     0,   158,    27,   158,     0,
     158,    29,   158,     0,   158,    28,   158,     0,   158,    30,
     158,     0,    33,   158,     0,    31,    94,     0,    22,    94,
       0,    23,    94,     0,    15,   158,     0,    26,   158,     0,
      27,   158,     0,    28,   158,     0,    29,   158,     0,    30,
     158,     0,   158,    24,   158,     0,   158,    25,   158,     0,
     158,    17,   158,     0,   158,    16,   158,     0,   158,    15,
     158,     0,   158,     3,   177,     0,     0,     0,   158,    45,
      76,    46,   165,   155,    78,   166,   155,    77,     0,     0,
     158,    45,    76,    96,   167,   155,    77,     0,   158,    45,
      96,     0,     0,   158,    46,   168,   156,    78,     0,    34,
     158,     0,   158,    11,   158,     0,   158,     9,   158,     0,
     158,     7,   158,     0,   158,    10,   158,     0,   158,     8,
     158,     0,    12,   158,     0,    13,   158,     0,    14,   158,
       0,   158,     5,   158,     0,   158,     6,   158,     0,    70,
       0,   158,    40,   158,     0,   158,    43,   158,     0,   158,
      41,   158,     0,   158,    42,   158,     0,   158,    39,   158,
       0,    35,   158,     0,    36,   158,     0,    37,   158,     0,
      47,   150,    79,     0,   158,    31,   158,     0,     0,     0,
      94,    96,   169,   152,   170,   157,   158,     0,    45,    96,
      97,     0,     4,    96,    97,     0,     0,    40,    98,    76,
     150,    77,   171,   158,     0,     0,    38,    98,    76,   150,
      77,   172,   158,     0,     0,    38,    98,    31,    98,    76,
     150,    77,   173,   158,     0,     0,     0,   175,   158,     0,
       0,   174,    81,   176,   158,     0,   174,    81,     0,   158,
       0,   177,     4,   158,     0,     0,     0,    94,    96,   179,
     152,   180,   157,   178,     0,     0,   121,     4,   181,   158,
       0,   121,     0,    47,   178,    79,     0,    34,   178,     0,
     178,    11,   178,     0,   178,     9,   178,     0,   178,     7,
     178,     0,   178,    10,   178,     0,   178,     8,   178,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   620,   621,   625,   627,   630,   632,   636,   638,   640,
     642,   644,   646,   648,   652,   672,   675,   678,   681,   686,
     692,   703,   706,   718,   721,   721,   743,   769,   785,   793,
     798,   806,   811,   814,   817,   829,   834,   839,   844,   867,
     921,   924,   929,   931,   936,   938,   943,   951,   952,   956,
     958,   968,   978,   989,  1004,  1004,  1006,  1014,  1029,  1058,
    1066,  1070,  1072,  1076,  1084,  1084,  1089,  1089,  1101,  1109,
    1117,  1124,  1128,  1130,  1130,  1151,  1153,  1158,  1158,  1193,
    1210,  1212,  1224,  1226,  1231,  1231,  1303,  1321,  1322,  1324,
    1324,  1328,  1328,  1332,  1332,  1337,  1337,  1353,  1353,  1366,
    1368,  1371,  1378,  1387,  1420,  1420,  1425,  1430,  1432,  1437,
    1441,  1443,  1447,  1448,  1451,  1451,  1481,  1483,  1486,  1491,
    1493,  1496,  1501,  1503,  1506,  1511,  1513,  1517,  1542,  1549,
    1558,  1577,  1577,  1583,  1586,  1589,  1592,  1597,  1599,  1603,
    1611,  1616,  1619,  1629,  1632,  1632,  1645,  1647,  1652,  1654,
    1657,  1660,  1665,  1730,  1820,  1822,  1827,  1832,  1835,  1838,
    1841,  1846,  1849,  1870,  1870,  1900,  1906,  1912,  1915,  1918,
    1924,  1930,  1933,  1936,  1936,  2068,  2068,  2085,  2085,  2147,
    2182,  2185,  2185,  2190,  2190,  2195,  2198,  2201,  2204,  2207,
    2210,  2213,  2237,  2256,  2259,  2262,  2265,  2271,  2289,  2297,
    2305,  2311,  2317,  2336,  2339,  2342,  2345,  2348,  2351,  2354,
    2357,  2360,  2390,  2390,  2390,  2427,  2427,  2470,  2519,  2519,
    2574,  2577,  2587,  2597,  2607,  2613,  2616,  2624,  2632,  2640,
    2651,  2662,  2665,  2668,  2671,  2674,  2677,  2680,  2683,  2686,
    2689,  2692,  2746,  2746,  2746,  2753,  2756,  2759,  2759,  2809,
    2809,  2846,  2846,  2900,  2919,  2919,  2952,  2952,  2990,  2996,
    3005,  3024,  3024,  3024,  3031,  3031,  3043,  3053,  3056,  3059,
    3068,  3077,  3086,  3089
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "'?'", "':'", "UNTIL", "RELEASE", "IMPL", 
  "EQUIV", "OR", "XOR", "AND", "FINALLY", "GLOBALLY", "NEXT", "'|'", 
  "'^'", "'&'", "NE", "EQ", "GE", "LE", "'<'", "'>'", "ROL", "ROR", "'+'", 
  "'-'", "'*'", "'/'", "'%'", "'#'", "IS", "'~'", "'!'", "CARDINALITY", 
  "MIN", "MAX", "MAP", "EQUALS", "SUBSET", "MINUS", "UNION", "INTERSECT", 
  "ATOM", "'.'", "'['", "'('", "NUMBER", "CHARACTER", "NAME", "TRUE_", 
  "FALSE_", "UNDEFINED", "FATAL", "TYPEDEF", "CONST", "PLACE", "TRANS", 
  "IN", "OUT", "GATE", "REJECT_", "DEADLOCK", "ENUM", "ID", "STRUCT", 
  "QUEUE", "STACK", "RANGE", "EMPTY", "SFAIR", "WFAIR", "HIDE", "PROP", 
  "';'", "'{'", "'}'", "']'", "')'", "'='", "','", "start", "net", 
  "netcomponent", "type", "queue_stack", "typedefinition", "@1", 
  "constraint", "range_list", "range", "value", "value_", "typereference", 
  "number", "name_", "_opt_name", "name", "enum_name", "_opt_eq", 
  "enum_list", "delim", "comp_name", "comp_list", "next_eq", "func_name", 
  "function", "@2", "@3", "param_list", "_opt_capacity", "@4", 
  "_opt_const", "place", "@5", "placename", "place_init", "_opt_exclam", 
  "transition", "@6", "transname", "trans", "@7", "@8", "@9", "@10", 
  "@11", "_list_var_expr", "var_expr", "@12", "_opt_hide", "trans_places", 
  "_list_place_marking", "place_marking", "@13", "_opt_place", 
  "_nopt_place", "_nopt_trans", "gate_list", "gate", "verify", "prop", 
  "fairness", "@14", "fairness_strong", "fair", "fair_expr", "marking", 
  "marking_list", "marking_list_", "@15", "_opt_expr", "_opt__expr", 
  "struct_expr", "expr_", "expr", "quantifier", "formula", "@16", "@17", 
  "@18", "@19", "@20", "@21", "@22", "@23", "@24", "@25", "@26", "@27", 
  "@28", "@29", "@30", "arg_list", "@31", "@32", "colon_formula", 
  "qual_expr", "@33", "@34", "@35", NULL
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    82,    82,    83,    83,    83,    83,    84,    84,    84,
      84,    84,    84,    84,    85,    86,    86,    86,    86,    87,
      87,    87,    87,    87,    88,    87,    87,    87,    87,    89,
      90,    90,    91,    91,    91,    91,    92,    93,    94,    95,
      96,    96,    97,    97,    98,    98,    99,   100,   100,   101,
     101,   101,   101,   101,   102,   102,   103,   104,   104,   104,
     104,   105,   105,   106,   108,   107,   109,   107,   110,   110,
     110,   110,   111,   112,   111,   113,   113,   115,   114,   116,
     117,   117,   118,   118,   120,   119,   121,   122,   122,   123,
     122,   124,   122,   125,   122,   126,   122,   127,   122,   128,
     128,   128,   128,   129,   130,   129,   129,   131,   131,   132,
     133,   133,   134,   134,   135,   134,   136,   136,   136,   137,
     137,   137,   138,   138,   138,   139,   139,   140,   141,   141,
     142,   144,   143,   145,   145,   145,   145,   146,   146,   147,
     148,   149,   149,   150,   151,   150,   152,   152,   153,   153,
     153,   153,   154,   154,   155,   155,   156,   157,   157,   157,
     157,   158,   158,   159,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   160,   158,   161,   158,   162,   158,   158,
     158,   163,   158,   164,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   165,   166,   158,   167,   158,   158,   168,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   169,   170,   158,   158,   158,   171,   158,   172,
     158,   173,   158,   174,   175,   174,   176,   174,   174,   177,
     177,   179,   180,   178,   181,   178,   178,   178,   178,   178,
     178,   178,   178,   178
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     1,     1,     2,     2,     3,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     2,     2,     4,
       4,     4,     4,     1,     0,     3,     4,     5,     4,     3,
       3,     1,     1,     2,     3,     2,     1,     1,     1,     1,
       1,     1,     0,     1,     0,     1,     1,     0,     1,     0,
       1,     3,     3,     5,     1,     1,     1,     2,     4,     2,
       0,     1,     1,     1,     0,     5,     0,     7,     2,     4,
       2,     0,     0,     0,     3,     0,     2,     0,     7,     1,
       0,     3,     0,     2,     0,     5,     2,     0,     4,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     4,     0,
       1,     3,     2,     3,     0,     6,     2,     0,     2,     3,
       1,     3,     0,     2,     0,     5,     0,     2,     2,     1,
       2,     2,     1,     2,     2,     1,     3,     1,     2,     2,
       4,     0,     3,     1,     1,     2,     2,     1,     3,     1,
       1,     1,     3,     1,     0,     4,     0,     3,     0,     1,
       2,     3,     1,     3,     0,     1,     1,     1,     1,     1,
       1,     1,     2,     0,     5,     1,     1,     2,     1,     1,
       1,     1,     1,     0,     4,     0,     4,     0,     4,     3,
       2,     0,     4,     0,     5,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     0,     0,    10,     0,     7,     3,     0,     5,
       2,     3,     3,     3,     3,     3,     2,     2,     2,     3,
       3,     1,     3,     3,     3,     3,     3,     2,     2,     2,
       3,     3,     0,     0,     7,     3,     3,     0,     7,     0,
       7,     0,     9,     0,     0,     2,     0,     4,     2,     1,
       3,     0,     0,     7,     0,     4,     1,     3,     2,     3,
       3,     3,     3,     3
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,    41,    40,     0,   119,   122,     0,     0,   134,   133,
       0,     3,     0,     0,     7,     0,    38,     8,     9,    10,
       0,     0,    12,    13,    11,   131,     0,     0,     0,     0,
       0,    23,   161,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   169,   170,   168,
     165,   166,   171,   172,   231,   173,     0,    38,     0,   128,
     156,   129,    45,     0,     4,     0,     5,    63,     0,   120,
     121,    72,   124,   123,    82,   136,   135,     0,     0,     0,
       0,     0,     0,     0,    14,     0,   226,   227,   228,   200,
     198,   199,   201,   202,   203,   204,   205,   197,   175,   196,
     220,   237,   238,   239,     0,     0,   180,     0,     0,   143,
       0,   181,   242,   162,   163,   177,    79,   167,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     218,     0,     6,    61,     0,    62,    64,     0,    84,     0,
       0,     0,   266,     0,   132,   137,   139,     0,     0,    46,
      47,     0,     0,    39,     0,     0,    15,    16,     0,    24,
       0,    25,    43,   246,     0,     0,     0,     0,   245,   240,
     144,   168,   152,     0,   149,   146,   183,   146,   254,     0,
     259,   211,   229,   230,   223,   225,   222,   224,   221,   210,
     209,   208,   189,   186,   188,   190,   185,   187,   206,   207,
     191,   192,   194,   193,   195,   241,   179,   236,   232,   234,
     235,   233,     0,   217,     0,   130,     0,     0,     0,    75,
       0,    83,    87,   268,     0,   261,   264,    86,     0,     0,
       0,     0,     0,     0,    56,    57,    54,    22,    55,     0,
      48,     0,    19,     0,    20,    21,    28,    17,    18,     0,
      26,     0,     0,    31,     0,    32,    37,   155,   176,     0,
       0,     0,     0,     0,   174,     0,     0,   182,   146,   243,
       0,     0,   178,     0,   212,   215,     0,    68,    66,     0,
      65,    77,    74,    85,   267,   146,     0,   138,   271,   273,
     270,   272,   269,     0,    52,    47,    27,    33,   155,    29,
       0,     0,     0,   249,   247,   145,   140,   151,   153,     0,
     184,     0,   164,   256,   255,   260,     0,     0,   219,     0,
       0,    76,    80,    89,    91,    93,    97,    99,    95,   262,
     265,    58,     0,    30,    34,    36,     0,     0,     0,   147,
     157,   158,   159,   160,     0,     0,     0,     0,    67,    69,
      78,     0,     0,     0,     0,     0,   100,     0,     0,     0,
      53,   251,   250,   248,   244,   257,   213,   216,     0,   116,
      90,    92,    94,   125,   127,    98,    88,   102,   108,     0,
     106,    96,     0,     0,     0,   141,    81,     0,   110,     0,
       0,   101,    45,    63,   263,   252,     0,     0,   116,   109,
     113,   117,   118,     0,   126,   104,   214,   142,   111,   114,
     146,     0,   105,   115,     0,     0,     0
};

static const short yydefgoto[] =
{
     444,    12,    13,    14,   188,   177,    93,   191,   282,   283,
     284,   285,    66,   182,    67,   193,   126,   180,   271,   181,
     269,   265,   178,   166,    78,    17,   248,   349,   247,   167,
     250,   311,    18,   352,   127,   380,   168,    19,   252,   172,
     313,   381,   382,   383,   388,   384,   385,   386,   440,   387,
     400,   417,   418,   441,   419,    68,   173,   402,   403,    22,
      23,    24,    87,    25,   174,   175,   415,   416,   118,   292,
     297,   202,   203,   286,   328,   374,    70,   208,   120,   194,
     209,   205,   298,   346,   414,   347,   244,   207,   341,   368,
     367,   413,   300,   301,   375,   211,   176,   315,   389,   316
};

static const short yypact[] =
{
     336,-32768,-32768,   290,-32768,-32768,  1398,  1398,-32768,-32768,
      68,-32768,   660,   -25,-32768,    34,-32768,-32768,-32768,-32768,
     222,   606,-32768,-32768,-32768,   -14,   -13,    -6,    58,    69,
     218,-32768,   338,   181,  1398,  1398,  1398,  1398,   181,   181,
    1398,  1398,  1398,  1398,  1398,   181,   181,  1398,  1398,  1398,
    1398,  1398,    89,    76,  1398,   181,  1398,-32768,-32768,   607,
  -32768,-32768,-32768,-32768,-32768,-32768,   190,   108,   486,-32768,
    1470,-32768,-32768,   153,-32768,    59,-32768,-32768,   116,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,   382,    85,    28,
    1398,    85,   638,   131,-32768,   574,  1650,  1650,  1650,   765,
  -32768,-32768,   765,   765,   765,   765,   765,-32768,-32768,   765,
     765,   765,   765,   765,     3,   114,   296,   574,   -62,  1470,
    1042,-32768,   150,-32768,-32768,-32768,-32768,-32768,  1398,  1398,
    1398,  1398,  1398,  1398,  1398,  1398,  1398,  1398,  1398,  1398,
    1398,  1398,  1398,  1398,  1398,  1398,  1398,  1398,  1398,  1398,
    1398,  1398,  1398,   753,  1398,  1398,  1398,  1398,  1398,   111,
  -32768,  1398,-32768,-32768,   136,-32768,-32768,   683,   159,   382,
     382,   181,   193,   226,   119,-32768,   661,    61,   -34,-32768,
     268,   -21,   127,-32768,   166,   135,-32768,-32768,  1339,   -19,
     832,-32768,-32768,-32768,  1398,    76,  1398,  1398,-32768,-32768,
  -32768,   198,-32768,    77,-32768,   191,-32768,   191,    42,  1398,
    1470,   248,  1510,  1510,  1548,  1548,  1585,  1618,  1650,  1681,
    1711,  1740,  1767,  1767,  1790,  1790,  1790,  1790,  1811,  1811,
     405,   405,  1827,  1827,  1827,  1827,-32768,   360,   527,   267,
     267,   296,   225,-32768,  1398,-32768,   139,   176,  1398,   312,
     131,-32768,-32768,-32768,    15,-32768,-32768,-32768,   382,   382,
     382,   382,   382,   382,-32768,-32768,-32768,-32768,-32768,   252,
  -32768,  1398,-32768,   181,-32768,-32768,-32768,-32768,-32768,   144,
  -32768,   902,   206,-32768,   208,-32768,-32768,   220,   296,   216,
     205,   227,  1398,  1102,-32768,  1042,  1162,-32768,   191,-32768,
     100,  1398,  1510,  1398,-32768,-32768,   196,-32768,-32768,   175,
    1470,   259,-32768,   478,-32768,   191,  1398,-32768,   432,   432,
     354,   292,-32768,    61,-32768,   315,-32768,-32768,-32768,-32768,
     832,   972,  1398,-32768,-32768,-32768,  1470,-32768,-32768,   241,
  -32768,   310,-32768,   129,  1470,  1470,  1221,  1280,-32768,  1398,
     139,-32768,-32768,-32768,-32768,-32768,-32768,    60,   -14,-32768,
    1470,-32768,  1398,-32768,-32768,-32768,   253,  1398,  1398,-32768,
  -32768,-32768,-32768,-32768,  1398,  1398,   257,   254,  1470,-32768,
     334,   271,   271,  1398,  1398,   247,-32768,   130,  1398,   310,
  -32768,-32768,   765,   765,  1470,  1470,-32768,-32768,  1398,   276,
  -32768,-32768,   300,-32768,-32768,-32768,-32768,    60,-32768,    66,
  -32768,  1470,   382,  1398,  1280,-32768,   303,   346,-32768,   171,
    1398,-32768,   355,   345,   661,   765,   320,  1398,   276,-32768,
     400,-32768,-32768,   409,-32768,-32768,-32768,-32768,-32768,-32768,
     191,  1398,-32768,   303,   414,   417,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,   413,-32768,-32768,     1,-32768,   177,-32768,    98,
     107,   158,    37,  -170,     0,   314,    21,   179,   128,-32768,
    -176,   156,   394,-32768,-32768,    99,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,    79,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,    81,-32768,-32768,
     117,-32768,    72,-32768,-32768,    16,    32,-32768,   101,-32768,
  -32768,-32768,-32768,   211,-32768,   261,  -279,    92,  -188,-32768,
    -196,   235,-32768,  -282,    -5,   145,   326,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,  -163,-32768,-32768,-32768
};


#define	YYLAST		1873


static const short yytable[] =
{
      16,    69,    71,    16,    30,   273,   253,   254,   290,   291,
      72,   299,    16,   335,   339,    72,    20,   199,   279,   200,
      81,    72,   259,   260,   261,   262,   263,    92,    20,     1,
      72,    73,    21,    95,   195,     1,    77,    15,    16,    16,
      31,   266,    84,   267,    21,    16,    16,   268,   -44,    15,
      76,    94,    72,    72,   266,   117,   272,    85,    86,   280,
     268,  -107,     1,    88,   376,   377,   122,     1,    72,     1,
      89,   309,   -44,   114,   115,   100,   101,     1,     2,   196,
     -44,   -44,   107,   108,     2,   183,     1,    16,    16,   179,
       1,    16,    16,   189,   314,   192,   318,   319,   320,   321,
     322,   324,   340,   -49,    90,   -49,   330,    92,   -24,   -49,
    -107,     2,     1,   -44,   -44,   204,     2,   192,     2,   359,
     -44,  -253,   123,  -253,   171,    31,     2,    26,    31,    31,
     163,     1,   426,  -107,   162,     2,   -44,     1,   -44,     2,
       1,   -44,   -44,   -44,   366,    91,   -44,   -44,   437,    27,
      28,    29,   -44,    72,   294,   124,   245,   161,   295,   243,
     -60,     2,   -60,   164,    16,   -44,   -60,    16,   249,    16,
      16,   255,   430,    72,   236,   -44,     1,    72,   190,   342,
       2,   343,     1,   183,   206,   287,     2,   242,   125,     2,
     197,     1,   390,   251,   257,    72,   165,   256,   264,   -40,
     258,   246,   293,   408,    31,   274,   171,   171,  -258,   407,
    -258,   -71,   -40,   276,   -44,   -71,   289,   -71,   -44,     1,
     -44,     2,   326,     1,   121,     2,     1,     1,   431,   432,
     -44,     2,   -40,   -44,   -44,   -44,   -44,   -44,   296,   306,
       2,   266,   305,   275,   442,   -40,    72,   268,   -40,   424,
     -70,   266,   303,     1,   -70,   308,   -70,   268,    16,    16,
      16,    16,    16,    16,    92,   -24,   183,   307,     2,    16,
     323,   304,     2,   179,   348,     2,     2,   331,   -40,    79,
      80,   266,   333,    82,    83,   329,   200,   268,   337,   -36,
     204,     1,   332,   -44,    26,   171,   171,   171,   171,   171,
     171,   -44,     2,   263,   334,   -44,    31,   -44,   200,    16,
     158,   370,   159,   160,   371,   351,    27,    28,    29,   372,
     369,   373,   266,    72,   406,   287,   365,   -59,   268,   -59,
     391,   397,    26,   -59,   200,   396,    -1,     1,   398,   -41,
       2,   159,   160,   -50,   264,   -50,   350,   399,   270,   -50,
      72,  -112,   -41,  -112,    27,    28,    29,   183,    92,   -24,
      96,    97,    98,    99,   262,   263,   102,   103,   104,   105,
     106,   379,   -41,   109,   110,   111,   112,   113,   404,   405,
     116,   420,   119,     1,   427,   -41,     2,    16,   -41,   435,
     -51,     3,   -51,     4,     5,   270,   -51,   436,     6,     7,
     155,   156,   157,   158,   -41,   159,   160,     8,     9,   422,
      10,    11,    16,   439,   445,   404,   169,   446,   -41,    72,
    -103,   428,  -103,   429,   409,    75,  -103,   312,   363,   170,
     423,   198,     2,   149,   150,   151,   152,   153,   364,   327,
       5,   261,   262,   263,   154,   155,   156,   157,   158,   171,
     159,   160,   325,   362,   210,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   361,
     237,   238,   239,   240,   241,   184,   410,     1,   421,   -44,
     -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   433,   401,
     438,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,
     -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   317,
     288,   434,   119,   119,   358,   -44,   -44,   -44,   -44,   -44,
     338,   -44,   -44,   443,   412,   302,     2,   353,   354,   355,
       0,     0,     0,    79,    80,   -44,   -44,   -44,     0,     8,
       9,   356,     0,     0,   357,   -44,     0,   -44,   -44,   -44,
       0,   -44,   -44,   -44,   -44,   -44,     0,   -44,   156,   157,
     158,     0,   159,   160,   310,     1,     0,   -42,   -42,   -42,
     -42,   -42,   -42,   -42,   -42,   -42,     0,     0,     0,   -42,
     -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,
     -42,   -42,   -42,   -42,   -42,   -42,   -42,     1,   -40,     0,
       0,     0,     0,   -42,   -42,   -42,   -42,   -42,   336,   -42,
     -42,   -40,     0,     0,     2,     0,     0,   344,     0,   345,
       0,     0,     0,   -42,   -42,   -42,     0,     0,     0,     1,
     -44,   -40,   360,   -42,     0,   -42,   -42,   -42,     0,   -42,
     -42,   -42,   -42,   -42,   -40,   -42,     2,   -40,   119,     0,
      -2,     1,     0,    82,    83,   -44,   -44,   -44,   259,   260,
     261,   262,   263,     0,     0,   378,     0,   -44,   -44,   -44,
      26,   -44,   -44,     0,     1,     0,   185,   -40,     2,     0,
       0,     0,     0,   392,   393,     0,     0,     0,     0,     0,
     394,   395,    27,    28,    29,   186,   187,     0,     0,     0,
       2,     0,     0,     0,   411,     3,     0,     4,     5,     0,
       0,     0,     6,     7,   336,    26,     0,     0,     0,     0,
     -73,     8,     9,     2,    10,    74,     0,     0,     0,   425,
       0,     0,     0,     0,     0,     0,     0,    27,    28,    29,
       0,     0,     0,   336,     1,     0,   -44,   -44,   -44,   -44,
     -44,   -44,   -44,   -44,   -44,     0,     0,   336,   -44,   -44,
     -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,
     -44,   -44,   -44,   -44,   -44,   -44,     0,     0,     0,     0,
       0,     0,   -44,   -44,   -44,   -44,   -44,     0,   -44,   -44,
       0,     0,     0,     2,   154,   155,   156,   157,   158,     0,
     159,   160,   -44,   -44,   -44,     0,     0,     0,     0,     0,
       0,     0,   -44,     0,   -44,   -44,   -44,     0,   -44,   -44,
     -44,   -44,   -44,    32,   -44,     0,    33,     0,     0,     0,
       0,     0,     0,     0,    34,    35,    36,    37,     0,     0,
       0,     0,     0,     0,    38,    39,     0,     0,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,     0,    53,     0,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,    62,    63,     0,     0,     4,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   281,    64,    32,     0,     0,    33,  -154,    65,     0,
       0,  -154,     0,  -154,    34,    35,    36,    37,     0,     0,
       0,     0,     0,     0,    38,    39,     0,     0,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,     0,    53,     0,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,    62,    63,     0,     0,     4,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    64,    32,     0,     0,    33,  -154,    65,     0,
       0,  -154,     0,  -154,    34,    35,    36,    37,     0,     0,
       0,     0,     0,     0,    38,    39,     0,     0,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,     0,    53,     0,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,    62,    63,     0,     0,     4,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    64,    32,     0,     0,    33,   -35,    65,     0,
       0,   -35,     0,   -35,    34,    35,    36,    37,     0,     0,
       0,     0,     0,     0,    38,    39,     0,     0,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,     0,    53,     0,     0,     0,    54,    55,     0,    56,
      57,    58,   201,    60,    61,    62,    63,     0,     0,     4,
       0,     0,     0,    32,     0,     0,    33,     0,     0,     0,
       0,     0,    64,     0,    34,    35,    36,    37,    65,  -148,
       0,     0,     0,  -148,    38,    39,     0,     0,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,     0,    53,     0,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,    62,    63,     0,     0,     4,
       0,     0,     0,    32,     0,     0,    33,     0,     0,     0,
       0,     0,    64,     0,    34,    35,    36,    37,    65,  -150,
       0,     0,     0,  -150,    38,    39,     0,     0,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,     0,    53,     0,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,    62,    63,     0,     0,     4,
       0,     0,    32,     0,     0,    33,     0,     0,     0,     0,
       0,     0,    64,    34,    35,    36,    37,     0,    65,     0,
       0,  -154,     0,    38,    39,     0,     0,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
       0,    53,     0,     0,     0,    54,    55,     0,    56,    57,
      58,    59,    60,    61,    62,    63,     0,     0,     4,     0,
       0,    32,     0,     0,    33,     0,     0,     0,     0,     0,
       0,    64,    34,    35,    36,    37,     0,    65,     0,  -154,
       0,     0,    38,    39,     0,     0,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,     0,
      53,     0,     0,     0,    54,    55,     0,    56,    57,    58,
      59,    60,    61,    62,    63,     0,     0,     4,     0,     0,
      32,     0,     0,    33,     0,     0,     0,     0,     0,     0,
      64,    34,    35,    36,    37,     0,    65,  -154,     0,     0,
       0,    38,    39,     0,     0,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,     0,    53,
       0,     0,     0,    54,    55,     0,    56,    57,    58,    59,
      60,    61,    62,    63,     0,     0,     4,     0,     0,    32,
       0,     0,    33,     0,     0,     0,   277,   278,     0,    64,
      34,    35,    36,    37,     0,    65,     0,     0,     0,     0,
      38,    39,     0,     0,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,     0,    53,     0,
       0,     0,    54,    55,     0,    56,    57,    58,    59,    60,
      61,    62,    63,     0,     0,     4,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    64,     0,
       0,     0,     0,   128,    65,   129,   130,   131,   132,   133,
     134,   135,     0,     0,     0,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,     0,     0,   154,
     155,   156,   157,   158,     0,   159,   160,   131,   132,   133,
     134,   135,     0,     0,     0,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,     0,     0,   154,
     155,   156,   157,   158,     0,   159,   160,   133,   134,   135,
       0,     0,     0,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,     0,     0,   154,   155,   156,
     157,   158,     0,   159,   160,   134,   135,     0,     0,     0,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,     0,     0,   154,   155,   156,   157,   158,   135,
     159,   160,     0,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,     0,     0,   154,   155,   156,
     157,   158,     0,   159,   160,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,     0,     0,   154,
     155,   156,   157,   158,     0,   159,   160,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,     0,     0,
     154,   155,   156,   157,   158,     0,   159,   160,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,     0,     0,
     154,   155,   156,   157,   158,     0,   159,   160,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,     0,     0,   154,
     155,   156,   157,   158,     0,   159,   160,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,     0,     0,   154,   155,   156,   157,
     158,     0,   159,   160,   145,   146,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,     0,     0,   154,
     155,   156,   157,   158,     0,   159,   160,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,     0,     0,
     154,   155,   156,   157,   158,     0,   159,   160,   152,   153,
       0,     0,     0,     0,     0,     0,   154,   155,   156,   157,
     158,     0,   159,   160
};

static const short yycheck[] =
{
       0,     6,     7,     3,     3,   181,   169,   170,   196,   197,
      10,   207,    12,   292,   296,    15,     0,    79,   188,    81,
      20,    21,     7,     8,     9,    10,    11,    46,    12,     1,
      30,    10,     0,    33,    31,     1,    15,     0,    38,    39,
       3,    75,    21,    77,    12,    45,    46,    81,    14,    12,
      75,    30,    52,    53,    75,    55,    77,    71,    72,    78,
      81,     1,     1,    76,   346,   347,    66,     1,    68,     1,
      76,   247,     4,    52,    53,    38,    39,     1,    50,    76,
      14,    47,    45,    46,    50,    90,     1,    87,    88,    89,
       1,    91,    92,    92,    79,    95,   259,   260,   261,   262,
     263,   271,   298,    75,    46,    77,   282,    46,    47,    81,
      50,    50,     1,    47,    80,   120,    50,   117,    50,   315,
      31,    79,    14,    81,    87,    88,    50,    42,    91,    92,
      14,     1,   414,    73,    75,    50,    75,     1,    77,    50,
       1,    75,    81,    77,   332,    76,    80,    81,   427,    64,
      65,    66,    76,   153,    77,    47,   161,     4,    81,   159,
      75,    50,    77,    47,   164,    76,    81,   167,   167,   169,
     170,   171,     1,   173,   153,     4,     1,   177,    47,    79,
      50,    81,     1,   188,    34,   190,    50,    76,    80,    50,
      76,     1,   362,    34,   173,   195,    80,     4,   177,     1,
      81,   164,     4,    73,   167,    78,   169,   170,    79,   385,
      81,    75,    14,    78,    75,    79,   195,    81,    79,     1,
      81,    50,    78,     1,    34,    50,     1,     1,    57,    58,
       4,    50,    34,     7,     8,     9,    10,    11,    47,   244,
      50,    75,   242,    77,   440,    47,   246,    81,    50,   412,
      75,    75,     4,     1,    79,    79,    81,    81,   258,   259,
     260,   261,   262,   263,    46,    47,   271,   246,    50,   269,
     269,    46,    50,   273,    78,    50,    50,    69,    80,    57,
      58,    75,    77,    57,    58,    79,    81,    81,   293,    69,
     295,     1,    76,    75,    42,   258,   259,   260,   261,   262,
     263,    75,    50,    11,    77,    79,   269,    81,    81,   309,
      43,     1,    45,    46,     4,    56,    64,    65,    66,     9,
      79,    11,    75,   323,    77,   330,   331,    75,    81,    77,
      77,    77,    42,    81,    81,    78,     0,     1,     4,     1,
      50,    45,    46,    75,   323,    77,   309,    76,    80,    81,
     350,    75,    14,    77,    64,    65,    66,   362,    46,    47,
      34,    35,    36,    37,    10,    11,    40,    41,    42,    43,
      44,   350,    34,    47,    48,    49,    50,    51,   383,   384,
      54,    81,    56,     1,    81,    47,    50,   387,    50,    34,
      75,    55,    77,    57,    58,    80,    81,    77,    62,    63,
      40,    41,    42,    43,     4,    45,    46,    71,    72,   409,
      74,    75,   412,     4,     0,   420,    34,     0,    80,   419,
      75,    75,    77,    77,   387,    12,    81,   250,   330,    47,
     409,   117,    50,    28,    29,    30,    31,    32,   331,   281,
      58,     9,    10,    11,    39,    40,    41,    42,    43,   412,
      45,    46,   273,   325,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   323,
     154,   155,   156,   157,   158,    91,   387,     1,   407,     3,
       4,     5,     6,     7,     8,     9,    10,    11,   419,   382,
     428,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,   258,
     194,   420,   196,   197,   313,    39,    40,    41,    42,    43,
     295,    45,    46,   441,   389,   209,    50,    59,    60,    61,
      -1,    -1,    -1,    57,    58,    59,    60,    61,    -1,    71,
      72,    73,    -1,    -1,    76,    69,    -1,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    -1,    81,    41,    42,
      43,    -1,    45,    46,   248,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    -1,    -1,    -1,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,     1,     1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,   292,    45,
      46,    14,    -1,    -1,    50,    -1,    -1,   301,    -1,   303,
      -1,    -1,    -1,    59,    60,    61,    -1,    -1,    -1,     1,
      34,    34,   316,    69,    -1,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    47,    81,    50,    50,   332,    -1,
       0,     1,    -1,    57,    58,    59,    60,    61,     7,     8,
       9,    10,    11,    -1,    -1,   349,    -1,    71,    72,    73,
      42,    75,    76,    -1,     1,    -1,    48,    80,    50,    -1,
      -1,    -1,    -1,   367,   368,    -1,    -1,    -1,    -1,    -1,
     374,   375,    64,    65,    66,    67,    68,    -1,    -1,    -1,
      50,    -1,    -1,    -1,   388,    55,    -1,    57,    58,    -1,
      -1,    -1,    62,    63,   398,    42,    -1,    -1,    -1,    -1,
      47,    71,    72,    50,    74,    75,    -1,    -1,    -1,   413,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,    66,
      -1,    -1,    -1,   427,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    -1,    -1,   441,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    -1,    -1,    50,    39,    40,    41,    42,    43,    -1,
      45,    46,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    -1,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,     1,    81,    -1,     4,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    57,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    70,     1,    -1,    -1,     4,    75,    76,    -1,
      -1,    79,    -1,    81,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    57,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,     1,    -1,    -1,     4,    75,    76,    -1,
      -1,    79,    -1,    81,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    57,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,     1,    -1,    -1,     4,    75,    76,    -1,
      -1,    79,    -1,    81,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    57,
      -1,    -1,    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    12,    13,    14,    15,    76,    77,
      -1,    -1,    -1,    81,    22,    23,    -1,    -1,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    57,
      -1,    -1,    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    12,    13,    14,    15,    76,    77,
      -1,    -1,    -1,    81,    22,    23,    -1,    -1,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    57,
      -1,    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    12,    13,    14,    15,    -1,    76,    -1,
      -1,    79,    -1,    22,    23,    -1,    -1,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    57,    -1,
      -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    12,    13,    14,    15,    -1,    76,    -1,    78,
      -1,    -1,    22,    23,    -1,    -1,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    57,    -1,    -1,
       1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    12,    13,    14,    15,    -1,    76,    77,    -1,    -1,
      -1,    22,    23,    -1,    -1,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
      -1,    -1,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    57,    -1,    -1,     1,
      -1,    -1,     4,    -1,    -1,    -1,    67,    68,    -1,    70,
      12,    13,    14,    15,    -1,    76,    -1,    -1,    -1,    -1,
      22,    23,    -1,    -1,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    -1,
      -1,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    57,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    -1,     3,    76,     5,     6,     7,     8,     9,
      10,    11,    -1,    -1,    -1,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,     7,     8,     9,
      10,    11,    -1,    -1,    -1,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,     9,    10,    11,
      -1,    -1,    -1,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    10,    11,    -1,    -1,    -1,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,    11,
      45,    46,    -1,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#ifdef __cplusplus
# define YYSTD(x) std::x
#else
# define YYSTD(x) x
#endif

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
#  define YYSIZE_T YYSTD (size_t)
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#    define YYSIZE_T YYSTD (size_t)
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  ifdef __cplusplus
#   include <cstdlib> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T std::size_t
#  else
#   ifdef __STDC__
#    include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#    define YYSIZE_T size_t
#   endif
#  endif
#  define YYSTACK_ALLOC YYSTD (malloc)
#  define YYSTACK_FREE YYSTD (free)
# endif

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Relocate the TYPE STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Type, Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	yymemcpy ((char *) yyptr, (char *) (Stack),			\
		  yysize * (YYSIZE_T) sizeof (Type));			\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (Type) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# ifdef __cplusplus
#  include <cstddef> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T std::size_t
# else
#  ifdef __STDC__
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  ifdef __cplusplus
#   include <cstdio>  /* INFRINGES ON USER NAME SPACE */
#  else
#   include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYFPRINTF YYSTD (fprintf)
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace. [The following comment makes no
   sense to me.  Could someone clarify it?  --akim] Since this is
   uninitialized, it does not stop multiple parsers from coexisting.
   */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#if ! defined (yyoverflow) && ! defined (yymemcpy)
# if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#  define yymemcpy __builtin_memcpy
# else				/* not GNU C or C++ */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
#  if defined (__STDC__) || defined (__cplusplus)
yymemcpy (char *yyto, const char *yyfrom, YYSIZE_T yycount)
#  else
yymemcpy (yyto, yyfrom, yycount)
     char *yyto;
     const char *yyfrom;
     YYSIZE_T yycount;
#  endif
{
  register const char *yyf = yyfrom;
  register char *yyt = yyto;
  register YYSIZE_T yyi = yycount;

  while (yyi-- != 0)
    *yyt++ = *yyf++;
}
# endif
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 341 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# ifdef __cplusplus
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else /* !__cplusplus */
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif /* !__cplusplus */
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (short, yyss);
	YYSTACK_RELOCATE (YYSTYPE, yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (YYLTYPE, yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 3:
#line 626 "parser/maria.y"
{ pnwarn ("extraneous semicolon"); ;
    break;}
case 4:
#line 629 "parser/maria.y"
{ pnwarn ("extraneous semicolon"); ;
    break;}
case 14:
#line 654 "parser/maria.y"
{
	  if (yyvsp[0].s && theNet.getType (yyvsp[0].s)) {
	    thePrinter.printRaw ("ignoring redefinition of type ");
	    thePrinter.printQuoted (yyvsp[0].s);
	    thePrinter.finish ();
	    pnerrors++;
	    deleteType (yyvsp[-1].type); delete[] yyvsp[0].s;
	  }
	  else if (yyvsp[-1].type && yyvsp[0].s) {
	    checkName (yyvsp[0].s, ckType, "invalid type name ");
	    theNet.addType (*yyvsp[-1].type, yyvsp[0].s);
	  }
	  else {
	    deleteType (yyvsp[-1].type); delete[] yyvsp[0].s;
	  }
	;
    break;}
case 15:
#line 674 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 16:
#line 677 "parser/maria.y"
{ yyval.flag = true; ;
    break;}
case 17:
#line 680 "parser/maria.y"
{ yyval.flag = yyvsp[-1].flag; pnerror ("ignoring extraneous `queue'"); ;
    break;}
case 18:
#line 683 "parser/maria.y"
{ yyval.flag = yyvsp[-1].flag; pnerror ("ignoring extraneous `stack'"); ;
    break;}
case 19:
#line 688 "parser/maria.y"
{
	  if (!(yyval.type = yyvsp[-1].type))
	    yyval.type = new class StructType (*new class ComponentList);
	;
    break;}
case 20:
#line 694 "parser/maria.y"
{
	  if (numberParsed && yyvsp[-1].i > 0)
	    yyval.type = new class IdType (yyvsp[-1].i);
	  else {
	    if (numberParsed)
	      pnerror ("empty identifier pool");
	    yyval.type = NULL;
	  }
	;
    break;}
case 21:
#line 705 "parser/maria.y"
{ yyval.type = yyvsp[-1].componentList ? new class StructType (*yyvsp[-1].componentList) : NULL; emptyParsed = false; ;
    break;}
case 22:
#line 708 "parser/maria.y"
{
	  if (yyvsp[-1].componentList && !yyvsp[-1].componentList->getSize ()) {
	    pnerror ("missing component list for union");
	    delete yyvsp[-1].componentList, yyval.type = NULL;
	  }
	  else
	    yyval.type = yyvsp[-1].componentList ? new class UnionType (*yyvsp[-1].componentList) : NULL;

	  emptyParsed = false;
	;
    break;}
case 23:
#line 720 "parser/maria.y"
{ yyval.type = yyvsp[0].type; ;
    break;}
case 24:
#line 723 "parser/maria.y"
{ currentType = yyvsp[0].type; ;
    break;}
case 25:
#line 725 "parser/maria.y"
{
	  if ((yyval.type = yyvsp[-2].type) && yyvsp[0].constraint) {
	    yyval.type = copyType (yyval.type);
	    if (class Constraint* c = yyval.type->getConstraint ()) {
	      if (c->isDisjoint (*yyvsp[0].constraint)) {
		pnerror ("ignoring constraint that would make the type empty");
		delete yyvsp[0].constraint;
	      }
	      else
		c->restrict (*yyvsp[0].constraint, *yyval.type);
	    }
	    else
	      yyval.type->setConstraint (*yyvsp[0].constraint);
	  }
 	  else
 	    delete yyvsp[0].constraint;
	  currentType = NULL;
	;
    break;}
case 26:
#line 745 "parser/maria.y"
{
	  if (yyvsp[-1].type && !isOrdered (*yyvsp[-1].type)) {
	    deleteType (yyvsp[-3].type), deleteType (yyvsp[-1].type), yyval.type = NULL;
	  }
	  else if (yyvsp[-3].type && yyvsp[-1].type) {
	    card_t size = yyvsp[-1].type->getNumValues ();
	    if (!size || size == CARD_T_MAX || (maxIndex && size > maxIndex)) {
	      thePrinter.printRaw ("type ");
	      printType (*yyvsp[-1].type);
	      thePrinter.printRaw (" has too big domain for indexing");
	      if (size && size < CARD_T_MAX)
		thePrinter.printRaw (" (try -a0)");
	      thePrinter.finish ();
	      pnerrors++;
	      deleteType (yyvsp[-3].type), deleteType (yyvsp[-1].type), yyval.type = NULL;
	    }
	    else {
	      theNet.addType (*yyvsp[-3].type); theNet.addType (*yyvsp[-1].type);
	      yyval.type = new class VectorType (*yyvsp[-3].type, *yyvsp[-1].type);
	    }
	  }
	  else
	    deleteType (yyvsp[-3].type), deleteType (yyvsp[-1].type), yyval.type = NULL;
	;
    break;}
case 27:
#line 771 "parser/maria.y"
{
	  if (yyvsp[-4].type && numberParsed) {
	    if (!yyvsp[-1].i) {
	      pnerror ("empty buffer");
	      deleteType (yyvsp[-4].type), yyval.type = NULL;
	    }
	    else {
	      theNet.addType (*yyvsp[-4].type);
	      yyval.type = new class BufferType (*yyvsp[-4].type, yyvsp[-1].i, yyvsp[-2].flag);
	    }
	  }
	  else
	    deleteType (yyvsp[-4].type), yyval.type = NULL;
	;
    break;}
case 28:
#line 787 "parser/maria.y"
{
	  pnerror ("array dimension must be an ordered type");
	  deleteType (yyvsp[-3].type), yyval.type = NULL;
	;
    break;}
case 29:
#line 795 "parser/maria.y"
{ yyval.constraint = yyvsp[-1].constraint; ;
    break;}
case 30:
#line 800 "parser/maria.y"
{
 	  if ((yyval.constraint = yyvsp[-2].constraint) && yyvsp[0].range)
 	    yyval.constraint->append (*yyvsp[0].range);
 	  else
	    delete yyvsp[0].range;
	;
    break;}
case 31:
#line 808 "parser/maria.y"
{ if (yyvsp[0].range) (yyval.constraint = new class Constraint)->append (*yyvsp[0].range); else yyval.constraint = NULL; ;
    break;}
case 32:
#line 813 "parser/maria.y"
{ yyval.range = yyvsp[0].value ? new class Range (*yyvsp[0].value, *yyvsp[0].value) : NULL; ;
    break;}
case 33:
#line 816 "parser/maria.y"
{ yyval.range = yyvsp[0].value ? new class Range (currentType->getFirstValue (), *yyvsp[0].value) : 0; ;
    break;}
case 34:
#line 819 "parser/maria.y"
{
 	  if (yyvsp[-2].value && yyvsp[0].value) {
	    if (pnwarnings && *yyvsp[0].value < *yyvsp[-2].value)
	      pnwarn ("upper limit of range specified before lower limit");
 	    yyval.range = new class Range (*yyvsp[-2].value, *yyvsp[0].value);
	  }
	  else {
	    yyval.range = NULL; delete yyvsp[-2].value; delete yyvsp[0].value;
	  }
	;
    break;}
case 35:
#line 831 "parser/maria.y"
{ yyval.range = yyvsp[-1].value ? new class Range (*yyvsp[-1].value, currentType->getLastValue ()) : 0; ;
    break;}
case 36:
#line 836 "parser/maria.y"
{ yyval.value = ensureConstant (yyvsp[0].expr, currentType); ;
    break;}
case 37:
#line 841 "parser/maria.y"
{ yyval.value = ensureConstant (yyvsp[0].expr, currentType); ;
    break;}
case 38:
#line 846 "parser/maria.y"
{
	  if (!yyvsp[0].s) yyval.type = NULL;
	  else if ((yyval.type = const_cast<class Type*>(theNet.getType (yyvsp[0].s))));
	  else if (!strcmp (yyvsp[0].s, "bool"))
	    yyval.type = &const_cast<class BoolType&>(Net::getBoolType ());
	  else if (!strcmp (yyvsp[0].s, "int"))
	    yyval.type = &const_cast<class IntType&>(Net::getIntType ());
	  else if (!strcmp (yyvsp[0].s, "unsigned"))
	    yyval.type = &const_cast<class CardType&>(Net::getCardType ());
	  else if (!strcmp (yyvsp[0].s, "char"))
	    yyval.type = &const_cast<class CharType&>(Net::getCharType ());
	  else {
	    thePrinter.printRaw ("undefined type ");
	    thePrinter.printQuoted (yyvsp[0].s);
	    thePrinter.finish ();
	    pnerrors++;
	  }
	  delete[] yyvsp[0].s;
	;
    break;}
case 39:
#line 869 "parser/maria.y"
{
	  yyval.i = 0; numberParsed = false;

	  if (yyvsp[0].expr && yyvsp[0].expr->getType () && (yyvsp[0].expr = fold (yyvsp[0].expr)) &&
	      yyvsp[0].expr->getKind () == Expression::eConstant) {
	    const class Valuation empty;
	    class Value* v = yyvsp[0].expr->eval (empty);
	    assert (v && yyvsp[0].expr->getType ()->isConstrained (*v));
	    switch (v->getType ().getKind ()) {
	    case Type::tChar:
	      yyval.i = char_t (static_cast<const class LeafValue&>(*v));
	      if (pnwarnings) {
		thePrinter.printRaw ("Warning:converting ");
		thePrinter.print (char_t (yyval.i));
		thePrinter.printRaw (" to ");
		thePrinter.print (yyval.i);
		thePrinter.finish ();
	      }
	      break;
	    case Type::tInt:
	      numberParsed = true;
	      yyval.i = int_t (static_cast<const class LeafValue&>(*v));
	      if (pnwarnings) {
		thePrinter.printRaw ("Warning:converting ");
		thePrinter.print (int_t (yyval.i));
		thePrinter.printRaw (" to ");
		thePrinter.print (yyval.i);
		thePrinter.finish ();
	      }
	      break;
	    case Type::tCard:
	      numberParsed = true;
	      yyval.i = card_t (static_cast<const class LeafValue&>(*v));
	      break;
	    case Type::tEnum:
	      numberParsed = true;
	      yyval.i = card_t (static_cast<const class LeafValue&>(*v));
	      break;
	    default:
	      pnerror ("expression does not evaluate to a number");
	      break;
	    }

	    delete v;
	  }
	  else if (yyvsp[0].expr)
	    pnerror ("number expected, got expression");

	  yyvsp[0].expr->destroy ();
	;
    break;}
case 40:
#line 923 "parser/maria.y"
{ yyval.s = yyvsp[0].s; ;
    break;}
case 41:
#line 926 "parser/maria.y"
{ yyval.s = NULL; ;
    break;}
case 42:
#line 930 "parser/maria.y"
{ yyval.s = NULL; ;
    break;}
case 43:
#line 933 "parser/maria.y"
{ yyval.s = yyvsp[0].s; ;
    break;}
case 44:
#line 937 "parser/maria.y"
{ pnerror ("missing name"); yyval.s = NULL; ;
    break;}
case 45:
#line 940 "parser/maria.y"
{ yyval.s = yyvsp[0].s; ;
    break;}
case 46:
#line 945 "parser/maria.y"
{
	  if ((yyval.s = yyvsp[0].s))
	    checkName (yyval.s, ckEnum, "invalid enumeration constant name ");
	;
    break;}
case 49:
#line 957 "parser/maria.y"
{ yyval.type = NULL; pnerror ("missing enumeration value"); ;
    break;}
case 50:
#line 960 "parser/maria.y"
{
	  if (yyvsp[0].s)
	    addEnumeration (static_cast<class EnumType*>(yyval.type =
							 new class EnumType),
			    yyvsp[0].s);
	  else
	    yyval.type = NULL;
	;
    break;}
case 51:
#line 970 "parser/maria.y"
{
	  if (!(yyval.type = yyvsp[-2].type) && yyvsp[0].s)
	    addEnumeration (static_cast<class EnumType*>(yyval.type =
							 new class EnumType),
			    yyvsp[0].s);
	  else if (yyval.type && yyvsp[0].s)
	    addEnumeration (static_cast<class EnumType*>(yyval.type), yyvsp[0].s);
	;
    break;}
case 52:
#line 980 "parser/maria.y"
{
	  if (yyvsp[-2].s && numberParsed)
	    addEnumeration (static_cast<class EnumType*>(yyval.type =
							 new class EnumType),
			    yyvsp[-2].s, yyvsp[0].i);
	  else {
	    yyval.type = NULL; delete[] yyvsp[-2].s;
	  }
	;
    break;}
case 53:
#line 991 "parser/maria.y"
{
	  if (!numberParsed) {
	    yyval.type = yyvsp[-4].type; delete[] yyvsp[-2].s;
	  }
	  else if (!(yyval.type = yyvsp[-4].type) && yyvsp[-2].s)
	    addEnumeration (static_cast<class EnumType*>(yyval.type =
							 new class EnumType),
			    yyvsp[-2].s, yyvsp[0].i);
	  else if (yyval.type && yyvsp[-2].s)
	    addEnumeration (static_cast<class EnumType*>(yyval.type), yyvsp[-2].s, yyvsp[0].i);
	;
    break;}
case 56:
#line 1008 "parser/maria.y"
{
	  if ((yyval.s = yyvsp[0].s))
	    checkName (yyval.s, ckComp, "invalid component name ");
	;
    break;}
case 57:
#line 1016 "parser/maria.y"
{
	  if (yyvsp[-1].type && yyvsp[0].s) {
	    (yyval.componentList = new class ComponentList)->addComponent (yyvsp[0].s, *yyvsp[-1].type);
	    theNet.addType (*yyvsp[-1].type);
	  }
	  else {
	    deleteType (yyvsp[-1].type);
	    delete[] yyvsp[0].s;
	    yyval.componentList = NULL;
	  }

	  emptyParsed = false;
	;
    break;}
case 58:
#line 1031 "parser/maria.y"
{
	  if ((yyval.componentList = yyvsp[-3].componentList) && yyvsp[-1].type && yyvsp[0].s) {
	    if (emptyParsed)
	      pnerror ("extraneous delimiter in component list");

	    emptyParsed = false;

	    if ((*yyval.componentList)[yyvsp[0].s]) {
	      thePrinter.printRaw ("ignoring redefinition of component ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	      pnerrors++;
	      deleteType (yyvsp[-1].type);
	      delete[] yyvsp[0].s;
	    }
	    else {
	      yyval.componentList->addComponent (yyvsp[0].s, *yyvsp[-1].type);
	      theNet.addType (*yyvsp[-1].type);
	    }
	  }
	  else {
	    delete yyval.componentList;
	    deleteType (yyvsp[-1].type);
	    delete[] yyvsp[0].s;
	    yyval.componentList = NULL;
	  }
	;
    break;}
case 59:
#line 1060 "parser/maria.y"
{
	  yyval.componentList = yyvsp[-1].componentList;
	  if (emptyParsed)
	    pnerror ("extraneous delimiter in component list");
	  emptyParsed = true;
	;
    break;}
case 60:
#line 1067 "parser/maria.y"
{ yyval.componentList = new class ComponentList; emptyParsed = true; ;
    break;}
case 63:
#line 1078 "parser/maria.y"
{
	  if ((yyval.s = yyvsp[0].s))
	    checkName (yyvsp[0].s, ckFunc, "invalid function name ");
	;
    break;}
case 64:
#line 1086 "parser/maria.y"
{ currentType = yyvsp[-2].type; ;
    break;}
case 65:
#line 1088 "parser/maria.y"
{ defun (yyvsp[-4].type, yyvsp[-3].s, yyvsp[0].expr); ;
    break;}
case 66:
#line 1091 "parser/maria.y"
{
	  currentType = yyvsp[-4].type;
	  if (emptyParsed && currentArity)
	    pnerror ("extraneous delimiter after formal parameter list");
	  emptyParsed = false;
	;
    break;}
case 67:
#line 1098 "parser/maria.y"
{ defun (yyvsp[-6].type, yyvsp[-5].s, yyvsp[0].expr); ;
    break;}
case 68:
#line 1103 "parser/maria.y"
{
	  if (currentArity || currentParameters)
	    delete[] yyvsp[0].s;
	  else
	    addParameter (yyvsp[-1].type, yyvsp[0].s), emptyParsed = false;
	;
    break;}
case 69:
#line 1111 "parser/maria.y"
{
	  if (yyvsp[-1].type && yyvsp[0].s && emptyParsed)
	    pnerror ("extraneous delimiter in parameter list");
	  addParameter (yyvsp[-1].type, yyvsp[0].s);
	  emptyParsed = false;
	;
    break;}
case 70:
#line 1119 "parser/maria.y"
{
	  if (emptyParsed)
	    pnerror ("extraneous delimiter in parameter list");
	  emptyParsed = true;
	;
    break;}
case 71:
#line 1125 "parser/maria.y"
{ if (!currentArity && !currentParameters) emptyParsed = true; ;
    break;}
case 72:
#line 1129 "parser/maria.y"
{ yyval.constraint = NULL; ;
    break;}
case 73:
#line 1132 "parser/maria.y"
{ currentType = &Net::getCardType (); ;
    break;}
case 74:
#line 1134 "parser/maria.y"
{
	  if (!(yyval.constraint = yyvsp[-2].constraint))
	    yyval.constraint = yyvsp[0].constraint;
	  else {
	    if (yyval.constraint->isDisjoint (*yyvsp[0].constraint)) {
	      pnerror ("ignoring contradictory capacity constraint");
	      delete yyvsp[-2].constraint; delete yyvsp[0].constraint;
	      yyval.constraint = NULL;
	    }
	    else {
	      yyval.constraint->restrict (*yyvsp[0].constraint, *currentType); delete yyvsp[0].constraint;
	    }
	  }
	  currentType = NULL;
	;
    break;}
case 75:
#line 1152 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 76:
#line 1155 "parser/maria.y"
{ if (yyvsp[-1].flag) pnerror ("ignoring extraneous `const'"); yyval.flag = true; ;
    break;}
case 77:
#line 1160 "parser/maria.y"
{
	  currentPlace = NULL;
	  if ((currentType = yyvsp[-1].type))
	    theNet.addType (*yyvsp[-1].type);

	  if (yyvsp[-3].s && yyvsp[-1].type) {
	    if (theNet.getPlace (yyvsp[-3].s)) {
	      thePrinter.printRaw ("ignoring redefinition of place ");
	      thePrinter.printQuoted (yyvsp[-3].s);
	      thePrinter.finish ();
	      pnerrors++;
	      delete[] yyvsp[-3].s; delete yyvsp[-2].constraint;
	    }
	    else {
	      checkName (yyvsp[-3].s, ckPlace, "invalid place name ");
	      (currentPlace = &theNet.addPlace (yyvsp[-3].s, yyvsp[-2].constraint, *yyvsp[-1].type))
		->setConstant (yyvsp[0].flag);
	    }
	  }
	  else {
	    delete[] yyvsp[-3].s; delete yyvsp[-2].constraint;
	  }
	;
    break;}
case 78:
#line 1184 "parser/maria.y"
{
	  if (currentPlace && yyvsp[0].marking)
	    currentPlace->setInitMarking (*yyvsp[0].marking);
	  else
	    yyvsp[0].marking->destroy ();
	  currentType = NULL, currentPlace = NULL;
	;
    break;}
case 79:
#line 1195 "parser/maria.y"
{
	  if (yyvsp[0].s) {
	    if (!(yyval.place = const_cast<class Place*>(theNet.getPlace (yyvsp[0].s)))) {
	      thePrinter.printRaw ("undefined place ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	      pnerrors++;
	    }
	  }
	  else
	    yyval.place = NULL;
	  delete[] yyvsp[0].s;
	;
    break;}
case 80:
#line 1211 "parser/maria.y"
{ yyval.marking = NULL; ;
    break;}
case 81:
#line 1214 "parser/maria.y"
{
	  if (!(yyval.marking = yyvsp[-2].marking))
	    yyval.marking = yyvsp[0].marking;
	  else {
	    pnerror ("multiple init blocks"); yyvsp[0].marking->destroy ();
	  }
	  currentExpressions.clear ();
	;
    break;}
case 82:
#line 1225 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 83:
#line 1228 "parser/maria.y"
{ if (yyvsp[-1].flag) pnerror ("ignoring extraneous `!'"); yyval.flag = true; ;
    break;}
case 84:
#line 1233 "parser/maria.y"
{
	  if (yyvsp[-1].s) {
	    if ((currentTransition = theNet.getTransition (yyvsp[-1].s))) {
	      pnwarn ("augmenting transition definition");
	      delete[] yyvsp[-1].s;
	    }
	    else {
	      checkName (yyvsp[-1].s, ckTrans, "invalid transition name ");
	      currentTransition = &theNet.addTransition (yyvsp[-1].s);
	    }
	    currentTransition->setPrioritized (yyvsp[0].flag);
	  }
	  else
	    currentTransition = NULL;

	  currentExpressions.clear ();
	;
    break;}
case 85:
#line 1251 "parser/maria.y"
{
	  currentExpressions.clear ();
	  if (currentTransition) {
	    if (const class QuantifierList* q =
		currentTransition->getOutputVariables ()) {
	      for (QuantifierList::const_iterator i = q->begin ();
		   i != q->end (); i++) {
		const class VariableDefinition& v = (*i)->getVariable ();

		if (currentTransition->isInput (&v)) {
		  thePrinter.printRaw ("output variable ");
		  thePrinter.printQuoted (v.getName ());
		  thePrinter.printRaw (" encountered on an input arc");
		  thePrinter.finish ();
		  pnerrors++;
		}
		if (currentTransition->isGate (&v)) {
		  thePrinter.printRaw ("output variable ");
		  thePrinter.printQuoted (v.getName ());
		  thePrinter.printRaw (" encountered on a gate");
		  thePrinter.finish ();
		  pnerrors++;
		}
		if (!currentTransition->isOutput (&v)) {
		  thePrinter.printRaw ("output variable ");
		  thePrinter.printQuoted (v.getName ());
		  thePrinter.printRaw (" not used on output arcs");
		  thePrinter.finish ();
		  pnerrors++;
		}
	      }
	    }
	    if (currentTransition->isInput (0)) {
	      thePrinter.printRaw ("an input arc refers to place contents");
	      thePrinter.finish ();
	      pnerrors++;
	    }
	    if (currentTransition->isGate (0)) {
	      thePrinter.printRaw ("a gate refers to place contents");
	      thePrinter.finish ();
	      pnerrors++;
	    }
	    if (!currentTransition->hasInputs () &&
		currentTransition->hasOutputs ())
	      pnwarn ("transition has output arcs but no inputs");
	    if (!currentTransition->isUnifiable (thePrinter))
	      pnerror ("transition cannot be unified");
	  }
	  currentTransition = NULL;
	;
    break;}
case 86:
#line 1305 "parser/maria.y"
{
	  if (yyvsp[0].s) {
	    if (!(yyval.trans = const_cast<class Transition*>(theNet.getTransition
						     (yyvsp[0].s)))) {
	      thePrinter.printRaw ("undefined transition ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	      pnerrors++;
	    }
	  }
	  else
	    yyval.trans = NULL;
	  delete[] yyvsp[0].s;
	;
    break;}
case 89:
#line 1326 "parser/maria.y"
{ isOutputArc = false; ;
    break;}
case 91:
#line 1330 "parser/maria.y"
{ isOutputArc = true; ;
    break;}
case 93:
#line 1334 "parser/maria.y"
{ currentType = &Net::getBoolType (); ;
    break;}
case 94:
#line 1336 "parser/maria.y"
{ currentType = NULL; ;
    break;}
case 95:
#line 1339 "parser/maria.y"
{ currentContextTransition = currentTransition; ;
    break;}
case 96:
#line 1341 "parser/maria.y"
{
	  if (currentTransition &&
	      ((yyvsp[0].expr && yyvsp[0].expr->getKind () == Expression::eMarking &&
		yyvsp[0].expr->getType () && yyvsp[0].expr->getType ()->getKind () == Type::tBool) ||
	      (yyvsp[0].expr = ensureBool (ensureExpr (yyvsp[0].expr))))) {
	    if (!theNet.addFairness (*CSE (yyvsp[0].expr), *currentTransition, yyvsp[-2].flag))
	      pnerror ("error in fairness constraint");
	  }
	  else
	    yyvsp[0].expr->destroy ();
	  currentContextTransition = NULL;
	;
    break;}
case 97:
#line 1355 "parser/maria.y"
{ currentContextTransition = currentTransition; ;
    break;}
case 98:
#line 1357 "parser/maria.y"
{
	  if (currentTransition && (yyvsp[0].expr = ensureBool (yyvsp[0].expr)))
	    currentTransition->addHide (*CSE (yyvsp[0].expr));
	  else
	    yyvsp[0].expr->destroy ();
	  currentContextTransition = NULL;
	;
    break;}
case 99:
#line 1367 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 100:
#line 1370 "parser/maria.y"
{ yyval.flag = true; ;
    break;}
case 101:
#line 1373 "parser/maria.y"
{
	  if (!yyvsp[-2].flag)
	    pnerror ("extraneous delimiter before variable definition");
	  yyval.flag = true;
	;
    break;}
case 102:
#line 1380 "parser/maria.y"
{
	  if (!yyvsp[-1].flag)
	    pnerror ("extraneous delimiter in variable definition list");
	  yyval.flag = false;
	;
    break;}
case 103:
#line 1389 "parser/maria.y"
{
	  if (yyvsp[-1].type && yyvsp[0].s && currentTransition) {
	    if (currentTransition->getVariable (yyvsp[0].s)) {
	      thePrinter.printRaw ("redefinition of variable ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	      pnerrors++;
	      delete[] yyvsp[0].s;
	    }
	    else {
	      currentTransition->addVariable (yyvsp[0].s, *yyvsp[-1].type, false, yyvsp[-2].flag);
	      checkName (yyvsp[0].s, ckVar, "invalid variable name ");
	      if (pnwarnings) {
		if (getConstant (yyvsp[0].s) || getConstantFunction (yyvsp[0].s)) {
		  thePrinter.printRaw ("Warning:variable ");
		  thePrinter.printQuoted (yyvsp[0].s);
		  thePrinter.printRaw (" shadows a constant");
		  thePrinter.finish ();
		}
		else if (theNet.getType (yyvsp[0].s)) {
		  thePrinter.printRaw ("Warning:variable ");
		  thePrinter.printQuoted (yyvsp[0].s);
		  thePrinter.printRaw (" shadows a type name");
		  thePrinter.finish ();
		}
	      }
	    }
	  }
	  else
	    delete[] yyvsp[0].s;
	;
    break;}
case 104:
#line 1422 "parser/maria.y"
{ beginAny (yyvsp[-2].type, yyvsp[-1].s, yyvsp[-3].flag); ;
    break;}
case 105:
#line 1424 "parser/maria.y"
{ endAny (yyvsp[-4].type, yyvsp[-3].s, yyvsp[0].expr)->destroy (); ;
    break;}
case 106:
#line 1427 "parser/maria.y"
{ if (yyvsp[-1].flag) pnerror ("ignoring meaningless `hide'"); ;
    break;}
case 107:
#line 1431 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 108:
#line 1434 "parser/maria.y"
{ yyval.flag = true; if (yyvsp[-1].flag) pnerror ("ignoring extraneous `hide'"); ;
    break;}
case 113:
#line 1450 "parser/maria.y"
{;
    break;}
case 114:
#line 1453 "parser/maria.y"
{
	  currentType = (currentPlace = yyvsp[-1].place) ? &yyvsp[-1].place->getType () : NULL;
	;
    break;}
case 115:
#line 1457 "parser/maria.y"
{
	  if (!currentPlace || !currentTransition)
	    yyvsp[0].marking->destroy ();
	  else if (yyvsp[0].marking) {
	    if (class Arc* arc =
		currentTransition->getArc (isOutputArc, *currentPlace)) {
	      if (pnwarnings) {
		thePrinter.printRaw ("Warning:extending arc ");
		thePrinter.printRaw (isOutputArc
				     ? "to place "
				     : "from place ");
		thePrinter.printQuoted (currentPlace->getName ());
		thePrinter.finish ();
	      }
	      arc->append (*yyvsp[0].marking);
	    }
	    else
	      currentTransition->addArc (*new class Arc
					 (isOutputArc, *yyvsp[0].marking, *currentPlace));
	  }
	  currentPlace = NULL, currentType = NULL;
	;
    break;}
case 116:
#line 1482 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 117:
#line 1485 "parser/maria.y"
{ yyval.flag = true; if (yyvsp[-1].flag) pnerror ("ignoring extraneous `place'"); ;
    break;}
case 118:
#line 1488 "parser/maria.y"
{ yyval.flag = yyvsp[-1].flag; pnerror ("expected `place', got `trans'"); ;
    break;}
case 120:
#line 1495 "parser/maria.y"
{ pnerror ("ignoring extraneous `place'"); ;
    break;}
case 121:
#line 1498 "parser/maria.y"
{ pnerror ("ignoring extraneous `trans'"); ;
    break;}
case 123:
#line 1505 "parser/maria.y"
{ pnerror ("ignoring extraneous `trans'"); ;
    break;}
case 124:
#line 1508 "parser/maria.y"
{ pnerror ("ignoring extraneous `place' after `trans'"); ;
    break;}
case 127:
#line 1519 "parser/maria.y"
{
	  if ((yyvsp[0].expr = ensureBool (ensureExpr (yyvsp[0].expr))) && currentTransition) {
	    if (yyvsp[0].expr->getKind () == Expression::eConstant) {
	      const class Value& v =
		static_cast<const class Constant*>(yyvsp[0].expr)->getValue ();
	      assert (v.getKind () == Value::vLeaf);
	      if (bool (static_cast<const class LeafValue&>(v))) {
		pnwarn ("gate is constantly enabled");
		yyvsp[0].expr->destroy ();
	      }
	      else {
		pnwarn ("gate is constantly disabled");
		currentTransition->addGate (*yyvsp[0].expr);
	      }
	    }
	    else
	      currentTransition->addGate (*yyvsp[0].expr);
	  }
	  else
	    yyvsp[0].expr->destroy ();
	;
    break;}
case 128:
#line 1544 "parser/maria.y"
{
	  if ((yyvsp[0].expr && yyvsp[0].expr->getKind () == Expression::eUndefined) ||
	      (yyvsp[0].expr = ensureBool (yyvsp[0].expr)))
	    theNet.addReject (*yyvsp[0].expr);
	;
    break;}
case 129:
#line 1551 "parser/maria.y"
{
	  if ((yyvsp[0].expr && yyvsp[0].expr->getKind () == Expression::eUndefined) ||
	      (yyvsp[0].expr = ensureBool (yyvsp[0].expr)))
	    theNet.addDeadlock (*yyvsp[0].expr);
	;
    break;}
case 130:
#line 1560 "parser/maria.y"
{
	  if ((yyvsp[0].expr = ensureBool (yyvsp[0].expr)) && yyvsp[-2].s) {
	    if (!theNet.addProp (yyvsp[-2].s, *yyvsp[0].expr)) {
	      thePrinter.printRaw ("redefinition of state proposition ");
	      thePrinter.printQuoted (yyvsp[-2].s);
	      thePrinter.finish ();
	      pnerrors++;
	      delete[] yyvsp[-2].s;
	      yyvsp[0].expr->destroy ();
	    }
	  }
	  else {
	    delete[] yyvsp[-2].s; yyvsp[0].expr->destroy ();
	  }
	;
    break;}
case 131:
#line 1579 "parser/maria.y"
{ isFairnessStrong = yyvsp[0].flag; ;
    break;}
case 133:
#line 1585 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 134:
#line 1588 "parser/maria.y"
{ yyval.flag = true; ;
    break;}
case 135:
#line 1591 "parser/maria.y"
{ yyval.flag = yyvsp[-1].flag; pnerror ("ignoring extraneous `weakly_fair'"); ;
    break;}
case 136:
#line 1594 "parser/maria.y"
{ yyval.flag = yyvsp[-1].flag; pnerror ("ignoring extraneous `strongly_fair'"); ;
    break;}
case 139:
#line 1605 "parser/maria.y"
{
	  if (yyvsp[0].expr && !theNet.addFairness (*yyvsp[0].expr, isFairnessStrong))
	    pnerror ("error in fairness constraint");
	;
    break;}
case 140:
#line 1613 "parser/maria.y"
{ yyval.marking = ensureMarking (yyvsp[0].expr, currentType); ;
    break;}
case 141:
#line 1618 "parser/maria.y"
{ yyval.marking = yyvsp[0].marking; ;
    break;}
case 142:
#line 1621 "parser/maria.y"
{
	  if ((yyval.marking = yyvsp[-2].marking) && yyvsp[0].marking)
	    yyval.marking->append (*yyvsp[0].marking);
	  else if (yyvsp[0].marking)
	    yyval.marking = yyvsp[0].marking;
	;
    break;}
case 143:
#line 1631 "parser/maria.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 144:
#line 1634 "parser/maria.y"
{ yyvsp[-1].expr = ensureMarking (yyvsp[-1].expr, currentType); ;
    break;}
case 145:
#line 1636 "parser/maria.y"
{
	  assert (!yyvsp[-3].expr || yyvsp[-3].expr->getKind () == Expression::eMarking);
	  if ((yyval.expr = yyvsp[-3].expr) && yyvsp[0].marking)
	    static_cast<class Marking*>(yyval.expr)->append (*yyvsp[0].marking);
	  else if (yyvsp[0].marking)
	    yyval.expr = yyvsp[0].marking;
	;
    break;}
case 146:
#line 1646 "parser/maria.y"
{ yyval.expr = NULL; ;
    break;}
case 147:
#line 1649 "parser/maria.y"
{ yyval.expr = yyvsp[-1].expr; ;
    break;}
case 148:
#line 1653 "parser/maria.y"
{ yyval.expr = NULL; ;
    break;}
case 149:
#line 1656 "parser/maria.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 150:
#line 1659 "parser/maria.y"
{ yyval.expr = namedComponent (yyvsp[-1].s, NULL); ;
    break;}
case 151:
#line 1662 "parser/maria.y"
{ yyval.expr = namedComponent (yyvsp[-2].s, yyvsp[0].expr); ;
    break;}
case 152:
#line 1667 "parser/maria.y"
{
	  if (currentContextType && !YYRECOVERING ()) {
	    assert (!currentComponent);

	    switch (currentContextType->getKind ()) {
	    case Type::tVector:
	      {
		const class VectorType* type =
		  static_cast<const class VectorType*>(currentContextType);
		class VectorExpression* v = new class VectorExpression (*type);

		if (!yyvsp[0].expr) {
		  pnerror ("missing expression for first vector component");
		  v->destroy (), yyval.expr = NULL;
		}
		else if (isCompatible (yyvsp[0].expr, currentType))
		  yyval.expr = v, v->setComponent (currentComponent, *yyvsp[0].expr);
		else
		  v->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
	      }
	      break;
	    case Type::tBuffer:
	      {
		const class BufferType* type =
		  static_cast<const class BufferType*>(currentContextType);
		class BufferExpression* b = new class BufferExpression (*type);

		if (!yyvsp[0].expr)
		  yyval.expr = b;
		else if (isCompatible (yyvsp[0].expr, currentType))
		  yyval.expr = b, b->append (*yyvsp[0].expr);
		else
		  b->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
	      }
	      break;
	    case Type::tStruct:
	      {
		if (!yyvsp[0].expr &&
		    !static_cast<const class StructType*>(currentContextType)
		    ->getSize ())
		  yyval.expr = CSE (new class Constant
			    (*new class StructValue (*currentContextType)));
		else {
		  class StructExpression* s =
		    new class StructExpression (*currentContextType);

		  if (isCompatible (yyvsp[0].expr, *s))
		    yyval.expr = s, s->append (*yyvsp[0].expr), currentType = s->getNextType ();
		  else
		    s->destroy (), yyvsp[0].expr->destroy (),
		      yyval.expr = NULL, currentType = NULL;
		}
	      }
	      break;
	    default:
	      assert (false);
	    }
	  }
	  else
	    yyvsp[0].expr->destroy (), yyval.expr = NULL;

	  currentComponent++;
	;
    break;}
case 153:
#line 1732 "parser/maria.y"
{
	  if ((yyval.expr = yyvsp[-2].expr) && currentContextType && !YYRECOVERING ()) {
	    assert (currentComponent > 0);
	    switch (currentContextType->getKind ()) {
	    case Type::tVector:
	      {
		assert (yyval.expr->getKind () == Expression::eVector);
		class VectorExpression* v =
		  static_cast<class VectorExpression*>(yyval.expr);
		const class VectorType* type =
		  static_cast<const class VectorType*>(currentContextType);

		if (currentComponent < type->getSize ()) {
		  if (!yyvsp[0].expr) {
		    thePrinter.printRaw ("missing array item ");
		    thePrinter.print (currentComponent);
		    thePrinter.finish ();
		    pnerrors++;
		    yyval.expr->destroy (), yyval.expr = NULL;
		  }
		  else if (isCompatible (yyvsp[0].expr, currentType))
		    v->setComponent (currentComponent, *yyvsp[0].expr);
		  else
		    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
		else {
		  thePrinter.printRaw ("too many items for array ");
		  printType (*type);
		  thePrinter.finish ();
		  pnerrors++;
		  yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
	      }
	      break;
	    case Type::tBuffer:
	      {
		assert (yyval.expr->getKind () == Expression::eBuffer);
		class BufferExpression* b =
		  static_cast<class BufferExpression*>(yyval.expr);
		const class BufferType* type =
		  static_cast<const class BufferType*>(currentContextType);

		if (b->hasCapacity ()) {
		  if (!yyvsp[0].expr || !b->getSize ()) {
		    thePrinter.printRaw ("missing buffer item ");
		    thePrinter.print (yyvsp[0].expr ? currentComponent : 0);
		    thePrinter.finish ();
		    pnerrors++;
		    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		  }
		  else if (isCompatible (yyvsp[0].expr, currentType))
		    b->append (*yyvsp[0].expr);
		  else
		    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
		else {
		  thePrinter.printRaw ("too many items for buffer ");
		  printType (*type);
		  thePrinter.finish ();
		  pnerrors++;
		  yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
	      }
	      break;
	    case Type::tStruct:
	      {
		assert (yyval.expr->getKind () == Expression::eStruct);
		class StructExpression* s =
		  static_cast<class StructExpression*>(yyval.expr);

		if (isCompatible (yyvsp[0].expr, *s))
		  s->append (*yyvsp[0].expr), currentType = s->getNextType ();
		else
		  yyval.expr->destroy (), yyvsp[0].expr->destroy (),
		    yyval.expr = NULL, currentType = NULL;
	      }
	      break;
	    default:
	      assert (false);
	    }
	  }
	  else
	    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;

	  currentComponent++;
	;
    break;}
case 154:
#line 1821 "parser/maria.y"
{ yyval.expr = NULL; pnerror ("missing expression"); ;
    break;}
case 155:
#line 1824 "parser/maria.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 156:
#line 1829 "parser/maria.y"
{ yyval.expr = ensureExpr (yyvsp[0].expr); ;
    break;}
case 157:
#line 1834 "parser/maria.y"
{ yyval.i = 0; ;
    break;}
case 158:
#line 1837 "parser/maria.y"
{ yyval.i = 1; ;
    break;}
case 159:
#line 1840 "parser/maria.y"
{ yyval.i = 2; ;
    break;}
case 160:
#line 1843 "parser/maria.y"
{ yyval.i = 3; ;
    break;}
case 161:
#line 1848 "parser/maria.y"
{ yyval.expr = NULL; ;
    break;}
case 162:
#line 1851 "parser/maria.y"
{
	  yyval.expr = NULL;
	  if (yyvsp[-1].s) {
	    if (class Function* f = getFunction (yyvsp[-1].s)) {
	      if (!(yyval.expr = fold (f->expand (NULL)))) {
		thePrinter.printRaw ("could not expand nullary function ");
		thePrinter.printQuoted (f->getName ());
		thePrinter.finish ();
		pnerrors++;
	      }
	    }
	    else {
	      thePrinter.printRaw ("there is no nullary function ");
	      thePrinter.printQuoted (yyvsp[-1].s);
	      thePrinter.finish ();
	      pnerrors++;
	    }
	  }
	;
    break;}
case 163:
#line 1872 "parser/maria.y"
{
	  class Function* f = NULL;
	  if (yyvsp[-1].s && !(f = getFunction (yyvsp[-1].s))) {
	    thePrinter.printRaw ("there is no function ");
	    thePrinter.printQuoted (yyvsp[-1].s);
	    thePrinter.finish ();
	    pnerrors++;
	  }
	  delete[] yyvsp[-1].s;
	  functionStack.push (f);
	;
    break;}
case 164:
#line 1884 "parser/maria.y"
{
	  assert (!functionStack.empty ());
	  if (class Function* f = functionStack.top ()) {
	    yyval.expr = NULL;
	    if (yyvsp[-1].exprList && !(yyval.expr = fold (f->expand (yyvsp[-1].exprList)))) {
	      thePrinter.printRaw ("could not expand function ");
	      thePrinter.printQuoted (f->getName ());
	      thePrinter.finish ();
	      pnerrors++;
	    }
	  }
	  else
	    yyval.expr = NULL;
	  yyvsp[-1].exprList->destroy ();
	  functionStack.pop ();
	;
    break;}
case 165:
#line 1902 "parser/maria.y"
{
	  yyval.expr = CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), true)));
	;
    break;}
case 166:
#line 1908 "parser/maria.y"
{
	  yyval.expr = CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), false)));
	;
    break;}
case 167:
#line 1914 "parser/maria.y"
{ yyval.expr = yyvsp[0].place ? CSE (new class PlaceContents (*yyvsp[0].place)) : NULL; ;
    break;}
case 168:
#line 1917 "parser/maria.y"
{ yyval.expr = resolveName (yyvsp[0].s); ;
    break;}
case 169:
#line 1920 "parser/maria.y"
{
	  yyval.expr = CSE (new class Constant
		    (*new class LeafValue (Net::getCardType (), yyvsp[0].i)));
	;
    break;}
case 170:
#line 1926 "parser/maria.y"
{
	  yyval.expr = CSE (new class Constant
		    (*new class LeafValue (Net::getCharType (), yyvsp[0].c)));
	;
    break;}
case 171:
#line 1932 "parser/maria.y"
{ yyval.expr = CSE (new class Undefined (Undefined::fError)); ;
    break;}
case 172:
#line 1935 "parser/maria.y"
{ yyval.expr = CSE (new class Undefined (Undefined::fFatalError)); ;
    break;}
case 173:
#line 1938 "parser/maria.y"
{
	  structLevels.push (StructLevel
			     (currentContextType, currentComponent));

	  if (!currentType) {
	    pnerror ("cannot determine type of structured expression");
	    currentContextType = NULL, currentComponent = 0;
	  }
	  else {
	    assert (!structLevels.empty () || !currentComponent);
	    currentContextType = currentType;
	    currentComponent = 0;

	    switch (currentType->getKind ()) {
	    case Type::tStruct:
	      currentType =
		static_cast<const class StructType*>(currentContextType)
		->getSize ()
		? &(*static_cast<const class StructType*>(currentContextType))
		[currentComponent]
		: NULL;
	      break;
	    case Type::tVector:
	      currentType =
		&static_cast<const class VectorType*>(currentContextType)
		->getItemType ();

	      if (pnwarnings) {
		const class Type& indexType =
		  static_cast<const class VectorType*>(currentContextType)
		  ->getIndexType ();

		switch (indexType.getKind ()) {
		case Type::tInt:
		case Type::tCard:
		case Type::tBool:
		case Type::tChar:
		case Type::tEnum:
		case Type::tId:
		  if (const class Constraint* constraint =
		      indexType.getConstraint ()) {
		    if (constraint->size () <= 1)
		      break;
		  }
		  else
		    break;
		default:
		  pnwarn ("initializing an array indexed by something else"
			  " than a simple continuous type");
		}
	      }

	      break;
	    case Type::tBuffer:
	      currentType =
		&static_cast<const class BufferType*>(currentContextType)
		->getItemType ();

	      break;
	    default:
	      pnerror ("cannot determine type of structured expression");
	      currentType = currentContextType = NULL;
	    }
	  }
	;
    break;}
case 174:
#line 2005 "parser/maria.y"
{
	  yyval.expr = yyvsp[-1].expr;
	  if (currentContextType) {
	    if (yyval.expr) {
	      switch (yyval.expr->getKind ()) {
	      case Expression::eStruct:
		{
		  class StructExpression* s =
		    static_cast<class StructExpression*>(yyval.expr);
		  if (s->getNextType ()) {
		    thePrinter.printRaw ("structure ");
		    printType (*currentContextType);
		    thePrinter.printRaw (" not fully initialized");
		    thePrinter.finish ();
		    pnerrors++;
		    yyval.expr->destroy (), yyval.expr = NULL;
		  }
		}
		break;

	      case Expression::eConstant:
	      case Expression::eBuffer:
		break;

	      case Expression::eVector:
		{
		  card_t diff =
		    static_cast<const class VectorType*>(currentContextType)
		    ->getSize () - currentComponent;

		  if (diff) {
		    thePrinter.print (diff);
		    thePrinter.printRaw (diff == 1
					 ? " element of array "
					 : " elements of array ");
		    printType (*currentContextType);
		    thePrinter.printRaw (" left uninitialized");
		    thePrinter.finish ();
		    pnerrors++;

		    yyval.expr->destroy (), yyval.expr = NULL;
		  }
		}
		break;

	      default:
		assert (false);
	      }
	    }

	    StructLevel p = structLevels.top ();
	    currentType = currentContextType;
	    currentContextType = p.first;
	    currentComponent = p.second;
	  }
	  else
	    currentComponent = 0;

	  structLevels.pop ();

	  if (yyval.expr)
	    yyval.expr = fold (yyval.expr);
	;
    break;}
case 175:
#line 2070 "parser/maria.y"
{ pushTypeContext (yyvsp[0].type); ;
    break;}
case 176:
#line 2072 "parser/maria.y"
{
	  if ((yyval.expr = yyvsp[0].expr) && yyval.expr->getKind () == Expression::eMarking &&
	      yyval.expr->getType () == currentType);
	  else if ((yyval.expr = noMarking (yyval.expr)) && currentType) {
	    if (!yyval.expr->getType ()) {
	      pnerror ("expression to cast has no type");
	      yyval.expr->destroy (), yyval.expr = NULL;
	    }
	    else
	      makeCompatible (yyval.expr, *currentType, true);
	  }
	  popTypeContext ();
	;
    break;}
case 177:
#line 2087 "parser/maria.y"
{
	  StructLevel p (currentContextType, currentComponent);
	  structLevels.push (p);
	  currentContextType = currentType;
	  currentType = NULL, currentComponent = 0;

	  if (yyvsp[-1].s && currentContextType &&
	      currentContextType->getKind () == Type::tUnion) {
	    const class UnionType* u =
	      static_cast<const class UnionType*>(currentContextType);

	    if ((currentType = (*u)[yyvsp[-1].s]))
	      currentComponent = u->getIndex (yyvsp[-1].s);
	    else {
	      thePrinter.printRaw ("type ");
	      printType (*u);
	      thePrinter.printRaw (" does not have component ");
	      thePrinter.printQuoted (yyvsp[-1].s);
	      thePrinter.finish ();
	      pnerrors++;
	    }
	  }
	  else if (yyvsp[-1].s)
	    pnerror ("cannot assign the component of a non-union type");

	  delete[] yyvsp[-1].s;
	;
    break;}
case 178:
#line 2115 "parser/maria.y"
{
	  if ((yyvsp[0].expr = ensureExpr (yyvsp[0].expr)) && currentType) {
	    const class UnionType* u =
	      static_cast<const class UnionType*>(currentContextType);

	    if (isCompatible (yyvsp[0].expr, currentType))
	      yyval.expr = fold (new class UnionExpression (*u, *yyvsp[0].expr,
						    currentComponent));
	    else {
	      thePrinter.printRaw ("type mismatch for ");
	      printType (*u);
	      thePrinter.printRaw (" component ");
	      thePrinter.printQuoted (u->getComponentName (currentComponent));
	      thePrinter.finish ();
	      pnerrors++;

	      yyvsp[0].expr->destroy (), yyval.expr = NULL;
	    }
	  }
	  else
	    yyvsp[0].expr->destroy (), yyval.expr = NULL;

	  assert (!structLevels.empty ());
	  StructLevel p = structLevels.top ();
	  currentType = currentContextType;
	  currentContextType = p.first;
	  currentComponent = p.second;
	  structLevels.pop ();

	  if (yyval.expr)
	    yyval.expr = fold (yyval.expr);
	;
    break;}
case 179:
#line 2149 "parser/maria.y"
{
	  if ((yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr)) && yyvsp[0].s) {
	    if (yyvsp[-2].expr->getType () && yyvsp[-2].expr->getType ()->getKind () == Type::tUnion) {
	      const class UnionType* u =
		static_cast<const class UnionType*>(yyvsp[-2].expr->getType ());

	      if ((*u)[yyvsp[0].s])
		yyval.expr = fold (new class UnionTypeExpression (*yyvsp[-2].expr,
							  u->getIndex (yyvsp[0].s)));
	      else {
		thePrinter.printRaw ("type ");
		printType (*u);
		thePrinter.printRaw (" does not have component ");
		thePrinter.printQuoted (yyvsp[0].s);
		thePrinter.finish ();
		pnerrors++;

		yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	      }
	    }
	    else {
	      pnerror ("cannot determine the component of a non-union value");
	      yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	    }
	  }
	  else
	    yyvsp[-2].expr->destroy (), yyval.expr = NULL;

	  delete[] yyvsp[0].s;

	  if (yyval.expr)
	    yyval.expr = fold (yyval.expr);
	;
    break;}
case 180:
#line 2184 "parser/maria.y"
{ if ((yyval.expr = noMarking (yyvsp[0].expr))) { yyval.expr->setAtomic (true); yyval.expr = CSE (yyval.expr); } ;
    break;}
case 181:
#line 2187 "parser/maria.y"
{ beginAny (yyvsp[-1].type, NULL, false); ;
    break;}
case 182:
#line 2189 "parser/maria.y"
{ yyval.expr = endAny (yyvsp[-3].type, NULL, yyvsp[0].expr); ;
    break;}
case 183:
#line 2192 "parser/maria.y"
{ beginAny (yyvsp[-2].type, yyvsp[-1].s, false); ;
    break;}
case 184:
#line 2194 "parser/maria.y"
{ yyval.expr = endAny (yyvsp[-4].type, yyvsp[-3].s, yyvsp[0].expr); ;
    break;}
case 185:
#line 2197 "parser/maria.y"
{ yyval.expr = newRelopExpression (false, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 186:
#line 2200 "parser/maria.y"
{ yyval.expr = newRelopExpression (true, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 187:
#line 2203 "parser/maria.y"
{ yyval.expr = newRelopExpression (false, yyvsp[0].expr, yyvsp[-2].expr); ;
    break;}
case 188:
#line 2206 "parser/maria.y"
{ yyval.expr = newNotExpression (newRelopExpression (false, yyvsp[-2].expr, yyvsp[0].expr)); ;
    break;}
case 189:
#line 2209 "parser/maria.y"
{ yyval.expr = newNotExpression (newRelopExpression (true, yyvsp[-2].expr, yyvsp[0].expr)); ;
    break;}
case 190:
#line 2212 "parser/maria.y"
{ yyval.expr = newNotExpression (newRelopExpression (false, yyvsp[0].expr, yyvsp[-2].expr)); ;
    break;}
case 191:
#line 2215 "parser/maria.y"
{
	  if (yyvsp[-2].expr && yyvsp[-2].expr->getType () &&
	      yyvsp[-2].expr->getType ()->getKind () == Type::tBuffer) {
	    const class BufferType* type =
	      static_cast<const class BufferType*>(yyvsp[-2].expr->getType ());
	    if ((yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr)) && (yyvsp[0].expr = ensureExpr (yyvsp[0].expr)) &&
		isCompatible (yyvsp[0].expr, &type->getItemType ())) {
	      if (yyvsp[-2].expr->getKind () == Expression::eBufferIndex) {
		class BufferIndex* b = static_cast<class BufferIndex*>(yyvsp[-2].expr);
		yyval.expr = fold (new class BufferWrite (b->getBuffer (), *yyvsp[0].expr,
						  &b->getIndex ()));
		b->destroy ();
	      }
	      else
		yyval.expr = fold (new class BufferWrite (*yyvsp[-2].expr, *yyvsp[0].expr, NULL));
	    }
	    else
	      yyvsp[-2].expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
	  }
	  else
	    yyval.expr = newBinopExpression (BinopExpression::bPlus, yyvsp[-2].expr, yyvsp[0].expr);
	;
    break;}
case 192:
#line 2239 "parser/maria.y"
{
	  if ((yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr)) && yyvsp[-2].expr->getType () &&
	      yyvsp[-2].expr->getType ()->getKind () == Type::tBuffer) {
	    if ((yyval.expr = ensureBuffer (yyvsp[-2].expr))) {
	      class Expression* index = 0;
	      if (yyval.expr->getKind () == Expression::eBufferIndex) {
		class BufferIndex* b = static_cast<class BufferIndex*>(yyval.expr);
		yyval.expr = &b->getBuffer ();
		index = &b->getIndex ();
		b->destroy ();
	      }
	      yyval.expr = fold (new class BufferRemove (*yyval.expr, ensureCard (yyvsp[0].expr), index));
	    }
	  }
	  else
	    yyval.expr = newBinopExpression (BinopExpression::bMinus, yyvsp[-2].expr, yyvsp[0].expr);
	;
    break;}
case 193:
#line 2258 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bDiv, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 194:
#line 2261 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bMul, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 195:
#line 2264 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bMod, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 196:
#line 2267 "parser/maria.y"
{
	  if ((yyval.expr = ensureIntCard (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uNot, *yyval.expr));
	;
    break;}
case 197:
#line 2273 "parser/maria.y"
{
	  if (yyvsp[0].type) {
	    card_t num = yyvsp[0].type->getNumValues ();
	    assert (num > 0);
	    if (num == CARD_T_MAX) {
	      pnerror ("type has too many values to count");
	      yyval.expr = NULL;
	    }
	    else
	      yyval.expr = CSE (new class Constant
			(*new class LeafValue
			 (Net::getCardType (), num)));
	  }
	  else
	    yyval.expr = NULL;
	;
    break;}
case 198:
#line 2291 "parser/maria.y"
{
	  if (yyvsp[0].type && isOrdered (*yyvsp[0].type))
	    yyval.expr = CSE (new class Constant (yyvsp[0].type->getFirstValue ()));
	  else
	    yyval.expr = NULL;
	;
    break;}
case 199:
#line 2299 "parser/maria.y"
{
	  if (yyvsp[0].type && isOrdered (*yyvsp[0].type))
	    yyval.expr = CSE (new class Constant (yyvsp[0].type->getLastValue ()));
	  else
	    yyval.expr = NULL;
	;
    break;}
case 200:
#line 2307 "parser/maria.y"
{
	  if ((yyval.expr = ensureOrdered (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uPred, *yyval.expr));
	;
    break;}
case 201:
#line 2313 "parser/maria.y"
{
	  if ((yyval.expr = ensureOrdered (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uSucc, *yyval.expr));
	;
    break;}
case 202:
#line 2319 "parser/maria.y"
{
	  if ((yyvsp[0].expr = ensureExpr (yyvsp[0].expr)) && yyvsp[0].expr->getType () &&
	      yyvsp[0].expr->getType ()->getKind () == Type::tBuffer) {
	    if ((yyval.expr = ensureBuffer (yyvsp[0].expr))) {
	      class Expression* index = 0;
	      if (yyval.expr->getKind () == Expression::eBufferIndex) {
		class BufferIndex* b = static_cast<class BufferIndex*>(yyval.expr);
		yyval.expr = &b->getBuffer ();
		index = &b->getIndex ();
		b->destroy ();
	      }
	      yyval.expr = fold (new class BufferRemove (*yyval.expr, 0, index));
	    }
	  }
	  else if ((yyval.expr = ensureIntCard (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uNeg, *yyval.expr));
	;
    break;}
case 203:
#line 2338 "parser/maria.y"
{ yyval.expr = newBufferUnop (BufferUnop::bPeek, yyvsp[0].expr); ;
    break;}
case 204:
#line 2341 "parser/maria.y"
{ yyval.expr = newBufferUnop (BufferUnop::bUsed, yyvsp[0].expr); ;
    break;}
case 205:
#line 2344 "parser/maria.y"
{ yyval.expr = newBufferUnop (BufferUnop::bFree, yyvsp[0].expr); ;
    break;}
case 206:
#line 2347 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bRol, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 207:
#line 2350 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bRor, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 208:
#line 2353 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bAnd, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 209:
#line 2356 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bXor, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 210:
#line 2359 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bOr, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 211:
#line 2362 "parser/maria.y"
{
	  yyvsp[-2].expr = noMarking (yyvsp[-2].expr);
	  if (yyvsp[-2].expr && yyvsp[0].exprList) {
	    if (!yyvsp[-2].expr->getType ()) {
	      pnerror ("left-hand-side of ? has no type");
	      yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy (); yyval.expr = NULL;
	    }
	    else if (yyvsp[-2].expr->getType ()->getNumValues () != yyvsp[0].exprList->size ()) {
	      thePrinter.printRaw ("left-hand-side of ? has ");
	      thePrinter.print (yyvsp[-2].expr->getType ()->getNumValues ());
	      thePrinter.printRaw ("!=");
	      thePrinter.print (yyvsp[0].exprList->size ());
	      thePrinter.printRaw (" possible values");
	      thePrinter.finish ();
	      pnerrors++;
	      yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy (); yyval.expr = NULL;
	    }
	    else if (yyvsp[-2].expr->getType ()->getNumValues () == 1) {
	      pnwarn ("left-hand-side of ? has only one possible value");
	      yyval.expr = (*yyvsp[0].exprList)[0].copy (); yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy ();
	    }
	    else
	      yyval.expr = fold (new class IfThenElse (*yyvsp[-2].expr, *yyvsp[0].exprList));
	  }
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 212:
#line 2392 "parser/maria.y"
{
	  if ((yyvsp[-3].expr = ensureExpr (yyvsp[-3].expr))) {
	    if (!yyvsp[-3].expr->getType () ||
		yyvsp[-3].expr->getType ()->getKind () != Type::tVector) {
	      pnerror ("left-hand-side of .{[index]expr} is not an array");
	      yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	    }
	    else
	      pushTypeContext (&static_cast<const class VectorType*>
			       (yyvsp[-3].expr->getType ())->getIndexType ());
	  }
	;
    break;}
case 213:
#line 2405 "parser/maria.y"
{
	  if (yyvsp[-6].expr)
	    currentType = &static_cast<const class VectorType*>(yyvsp[-6].expr->getType ())
	      ->getItemType ();
	;
    break;}
case 214:
#line 2411 "parser/maria.y"
{
	  if (yyvsp[-9].expr) {
	    currentType = yyvsp[-9].expr->getType ();
	    const class VectorType& type =
	      *static_cast<const class VectorType*>(currentType);

	    if (makeCompatible (yyvsp[-4].expr, type.getIndexType ()) &&
		makeCompatible (yyvsp[-1].expr, type.getItemType ()))
	      yyval.expr = fold (new class VectorAssign (*yyvsp[-9].expr, *yyvsp[-4].expr, *yyvsp[-1].expr));
	    else
	      yyvsp[-4].expr->destroy (), yyvsp[-1].expr->destroy (), yyvsp[-9].expr->destroy (), yyval.expr = NULL;
	    popTypeContext ();
	  }
	  else
	    yyvsp[-4].expr->destroy (), yyvsp[-1].expr->destroy (), yyval.expr = NULL;
	;
    break;}
case 215:
#line 2429 "parser/maria.y"
{
	  if ((yyvsp[-3].expr = ensureExpr (yyvsp[-3].expr)) && yyvsp[0].s) {
	    if (!yyvsp[-3].expr->getType () ||
		yyvsp[-3].expr->getType ()->getKind () != Type::tStruct) {
	      pnerror ("left-hand-side of .{comp expr} is not a struct");
	      yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	    }
	    const class StructType& type =
	      *static_cast<const class StructType*>(yyvsp[-3].expr->getType ());
	    if (const class Type* ct = type[yyvsp[0].s])
	      pushTypeContext (ct);
	    else {
	      thePrinter.printRaw ("type ");
	      printType (type);
	      thePrinter.printRaw (" does not have component ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	      pnerrors++;
	      yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	    }
	  }
	  else
	    yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	;
    break;}
case 216:
#line 2454 "parser/maria.y"
{
	  if (yyvsp[-6].expr) {
	    const class StructType& type =
	      *static_cast<const class StructType*>(yyvsp[-6].expr->getType ());
	    currentType = type[yyvsp[-3].s];
	    if (makeCompatible (yyvsp[-1].expr, *currentType))
	      yyval.expr =
		fold (new class StructAssign (*yyvsp[-6].expr, type.getIndex (yyvsp[-3].s), *yyvsp[-1].expr));
	    else
	      yyvsp[-1].expr->destroy (), yyvsp[-6].expr->destroy (), yyval.expr = NULL;
	    popTypeContext ();
	  }
	  else
	    yyvsp[-1].expr->destroy (), yyval.expr = NULL;
	  delete[] yyvsp[-3].s;
	;
    break;}
case 217:
#line 2472 "parser/maria.y"
{
	  yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr);
	  if (yyvsp[-2].expr && yyvsp[0].s) {
	    if (yyvsp[-2].expr->getType () &&
		yyvsp[-2].expr->getType ()->getKind () == Type::tStruct) {
	      const class StructType *s =
		static_cast<const class StructType*>(yyvsp[-2].expr->getType ());
	      if ((*s)[yyvsp[0].s])
		yyval.expr = fold (new class StructComponent (*yyvsp[-2].expr, s->getIndex (yyvsp[0].s)));
	      else {
		thePrinter.printRaw ("type ");
		printType (*s);
		thePrinter.printRaw (" does not have component ");
		thePrinter.printQuoted (yyvsp[0].s);
		thePrinter.finish ();
		pnerrors++;

		yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	      }
	    }
	    else if (yyvsp[-2].expr->getType () &&
		     yyvsp[-2].expr->getType ()->getKind () == Type::tUnion) {
	      const class UnionType *u =
		static_cast<const class UnionType*>(yyvsp[-2].expr->getType ());
	      if ((*u)[yyvsp[0].s])
		yyval.expr = fold (new class UnionComponent (*yyvsp[-2].expr, u->getIndex (yyvsp[0].s)));
	      else {
		thePrinter.printRaw ("type ");
		printType (*u);
		thePrinter.printRaw (" does not have component ");
		thePrinter.printQuoted (yyvsp[0].s);
		thePrinter.finish ();
		pnerrors++;

		yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	      }
	    }
	    else {
	      pnerror ("only unions and structs have components");
	      yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	    }
	  }
	  else
	    yyvsp[-2].expr->destroy (), yyval.expr = NULL;

	  delete[] yyvsp[0].s;
	;
    break;}
case 218:
#line 2521 "parser/maria.y"
{
	  if ((yyvsp[-1].expr = ensureExpr (yyvsp[-1].expr)) && yyvsp[-1].expr->getType ()) {
	    switch (yyvsp[-1].expr->getType ()->getKind ()) {
	    case Type::tVector:
	      {
		const class VectorType* type =
		  static_cast<const class VectorType*>(yyvsp[-1].expr->getType ());
		pushTypeContext (&type->getIndexType ());
	      }
	      break;
	    case Type::tBuffer:
	      if (yyvsp[-1].expr->getKind () == Expression::eBufferIndex)
		pnerror ("a buffer index has already been specified");
	      break;
	    default:
	      pnerror ("only vector-typed expressions can be indexed");
	      yyvsp[-1].expr->destroy (), yyvsp[-1].expr = NULL;
	    }
	  }
	  else if (yyvsp[-1].expr) {
	    pnerror ("no type for indexed expression");
	    yyvsp[-1].expr->destroy (), yyvsp[-1].expr = NULL;
	  }
	;
    break;}
case 219:
#line 2546 "parser/maria.y"
{
	  if (yyvsp[-4].expr) {
	    switch (yyvsp[-4].expr->getType ()->getKind ()) {
	    case Type::tVector:
	      {
		const class VectorType* type =
		  static_cast<const class VectorType*>(yyvsp[-4].expr->getType ());
		popTypeContext ();

		if (isCompatible (yyvsp[-1].expr, &type->getIndexType ()))
		  yyval.expr = fold (new class VectorIndex (*yyvsp[-4].expr, *yyvsp[-1].expr));
		else
		  yyval.expr = NULL, yyvsp[-4].expr->destroy (), yyvsp[-1].expr->destroy ();
	      }
	      break;
	    case Type::tBuffer:
	      if (yyvsp[-4].expr->getKind () == Expression::eBufferIndex)
		yyvsp[-1].expr->destroy (), yyval.expr = yyvsp[-4].expr;
	      else
		yyval.expr = yyvsp[-1].expr ? CSE (new class BufferIndex (*yyvsp[-4].expr, *yyvsp[-1].expr)) : yyvsp[-4].expr;
	      break;
	    default:
	      assert (false);
	    }
	  }
	  else
	    yyval.expr = NULL, yyvsp[-1].expr->destroy ();
	;
    break;}
case 220:
#line 2576 "parser/maria.y"
{ yyval.expr = newNotExpression (yyvsp[0].expr); ;
    break;}
case 221:
#line 2579 "parser/maria.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr, true);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (true, yyvsp[-2].expr, yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 222:
#line 2589 "parser/maria.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr, true);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (false, yyvsp[-2].expr, yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 223:
#line 2599 "parser/maria.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr, true);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (false, newNotExpression (yyvsp[-2].expr), yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 224:
#line 2609 "parser/maria.y"
{
	  yyval.expr = newNotExpression
	    (newRelopExpression (true, ensureBool (yyvsp[-2].expr), ensureBool (yyvsp[0].expr)));
	;
    break;}
case 225:
#line 2615 "parser/maria.y"
{ yyval.expr = newRelopExpression (true, ensureBool (yyvsp[-2].expr), ensureBool (yyvsp[0].expr)); ;
    break;}
case 226:
#line 2618 "parser/maria.y"
{
	  yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  yyval.expr = yyvsp[0].expr
	    ? CSE (new class TemporalUnop (TemporalUnop::Finally, *yyvsp[0].expr))
	    : NULL;
	;
    break;}
case 227:
#line 2626 "parser/maria.y"
{
	  yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  yyval.expr = yyvsp[0].expr
	    ? CSE (new class TemporalUnop (TemporalUnop::Globally, *yyvsp[0].expr))
	    : NULL;
	;
    break;}
case 228:
#line 2634 "parser/maria.y"
{
	  yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  yyval.expr = yyvsp[0].expr
	    ? CSE (new class TemporalUnop (TemporalUnop::Next, *yyvsp[0].expr))
	    : NULL;
	;
    break;}
case 229:
#line 2642 "parser/maria.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = CSE (new class TemporalBinop (TemporalBinop::Until,
					       *yyvsp[-2].expr, *yyvsp[0].expr));
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 230:
#line 2653 "parser/maria.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = CSE (new class TemporalBinop (TemporalBinop::Release,
					       *yyvsp[-2].expr, *yyvsp[0].expr));
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 231:
#line 2664 "parser/maria.y"
{ yyval.expr = CSE (new class EmptySet); ;
    break;}
case 232:
#line 2667 "parser/maria.y"
{ yyval.expr = newSetExpression (SetExpression::sSubset, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 233:
#line 2670 "parser/maria.y"
{ yyval.expr = newSetExpression (SetExpression::sIntersection, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 234:
#line 2673 "parser/maria.y"
{ yyval.expr = newSetExpression (SetExpression::sMinus, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 235:
#line 2676 "parser/maria.y"
{ yyval.expr = newSetExpression (SetExpression::sUnion, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 236:
#line 2679 "parser/maria.y"
{ yyval.expr = newSetExpression (SetExpression::sEquals, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 237:
#line 2682 "parser/maria.y"
{ yyval.expr = newCardinalityExpression (CardinalityExpression::cCard, yyvsp[0].expr); ;
    break;}
case 238:
#line 2685 "parser/maria.y"
{ yyval.expr = newCardinalityExpression (CardinalityExpression::cMin, yyvsp[0].expr); ;
    break;}
case 239:
#line 2688 "parser/maria.y"
{ yyval.expr = newCardinalityExpression (CardinalityExpression::cMax, yyvsp[0].expr); ;
    break;}
case 240:
#line 2691 "parser/maria.y"
{ yyval.expr = yyvsp[-1].expr; ;
    break;}
case 241:
#line 2694 "parser/maria.y"
{
	  yyvsp[-2].expr = ensureCard (yyvsp[-2].expr);
	  class Marking* m = ensureMarking (yyvsp[0].expr, currentType);

	  if ((yyval.expr = m) && yyvsp[-2].expr) {
	    if (yyvsp[-2].expr->getKind () == Expression::eConstant) {
	      const class Value& v =
		static_cast<class Constant*>(yyvsp[-2].expr)->getValue ();
	      assert (v.getKind () == Value::vLeaf);
	      card_t mult = card_t (static_cast<const class LeafValue&>(v));
	      if (!mult) {
		pnerror ("zero multiplicity");
		yyvsp[-2].expr->destroy (), m->destroy ();
		yyval.expr = m = NULL;
	      }
	      else if (mult == 1)
		yyvsp[-2].expr->destroy ();
	      else {
		for (;;) {
		  if (class Expression* c = m->getMultiplicity ()) {
		    class Expression* card =
		      fold (new class BinopExpression (BinopExpression::bMul,
						       *yyvsp[-2].expr, *c));
		    m->setMultiplicity (card);
		  }
		  else
		    m->setMultiplicity (yyvsp[-2].expr);

		  if ((m = const_cast<class Marking*>(m->getNext ())))
		    yyvsp[-2].expr = CSE (new class Constant
			      (*new class LeafValue (*yyvsp[-2].expr->getType (), mult)));
		  else
		    break;
		}
	      }
	    }
	    else {
	      if (m->getNext ())
		yyval.expr = m = static_cast<class Marking*>
		  (CSE (new class Marking (m->getPlace (), m)));

	      class Expression* card = yyvsp[-2].expr;

	      if (class Expression* c = m->getMultiplicity ())
		card = fold
		  (new class BinopExpression (BinopExpression::bMul, *yyvsp[-2].expr, *c));
	      m->setMultiplicity (card);
	    }
	  }
	  else
	    yyvsp[-2].expr->destroy ();
	;
    break;}
case 242:
#line 2748 "parser/maria.y"
{ beginQuantifier (yyvsp[0].s, yyvsp[-1].type); ;
    break;}
case 243:
#line 2750 "parser/maria.y"
{ continueQuantifier (ASSERT1 (yyvsp[-3].type)); ;
    break;}
case 244:
#line 2752 "parser/maria.y"
{ yyval.expr = endQuantifier (yyvsp[-5].s, yyvsp[-6].type, yyvsp[-3].expr, yyvsp[-1].i, yyvsp[0].expr, false); ;
    break;}
case 245:
#line 2755 "parser/maria.y"
{ yyval.expr = quantifierVariable (yyvsp[-1].s, yyvsp[0].s, false); ;
    break;}
case 246:
#line 2758 "parser/maria.y"
{ yyval.expr = quantifierVariable (yyvsp[-1].s, yyvsp[0].s, true); ;
    break;}
case 247:
#line 2761 "parser/maria.y"
{
	  if (yyvsp[-1].expr && yyvsp[-1].expr->getKind () == Expression::eEmptySet) {
	    pnwarn ("any subset of an empty set is an empty set");
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	  else if ((yyvsp[-1].expr = ensureSet (yyvsp[-1].expr)) && yyvsp[-3].s && yyvsp[-1].expr->getType ()) {
	    checkIterator (yyvsp[-3].s);
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-3].s, *yyvsp[-1].expr->getType (), false));
	  }
	  else
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	;
    break;}
case 248:
#line 2775 "parser/maria.y"
{
	  yyvsp[0].expr = ensureBool (ensureExpr (yyvsp[0].expr));
	  if ((yyval.expr = yyvsp[-3].expr) && yyvsp[0].expr && yyvsp[-5].s) {
	    yyvsp[0].expr = CSE (yyvsp[0].expr);
	    if (pnwarnings) {
	      class VariableSet vars;
	      vars.insert (*currentVariables.top ());
	      if (!yyvsp[0].expr->depends (vars, false)) {
		thePrinter.printRaw ("Warning:subset is independent of ");
		thePrinter.printQuoted (currentVariables.top ()->getName ());
		thePrinter.finish ();
	      }
	    }
	    if (yyvsp[0].expr->getKind () == Expression::eConstant) {
	      const class Value& v =
		static_cast<class Constant*>(yyvsp[0].expr)->getValue ();
	      assert (v.getKind () == Value::vLeaf);
	      bool result = bool (static_cast<const class LeafValue&>(v));
	      yyvsp[0].expr->destroy ();
	      pnwarn (result
		      ? "subset criterion always passes"
		      : "subset criterion always fails");
	      if (!result)
		yyval.expr->destroy (), yyval.expr = CSE (new class EmptySet);
	    }
	    else
	      yyval.expr = CSE (new class Submarking
			(*currentVariables.top (), *yyvsp[-3].expr, *yyvsp[0].expr));
	  }
	  else
	    yyvsp[0].expr->destroy ();
	  if (yyvsp[-5].s)
	    currentVariables.pop ();
	;
    break;}
case 249:
#line 2811 "parser/maria.y"
{
	  if (yyvsp[-1].expr && yyvsp[-1].expr->getKind () == Expression::eEmptySet) {
	    pnwarn ("any subset of an empty set is an empty set");
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	  else if ((yyvsp[-1].expr = ensureSet (yyvsp[-1].expr)) && yyvsp[-3].s && yyvsp[-1].expr->getType ()) {
	    checkIterator (yyvsp[-3].s);
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-3].s, *yyvsp[-1].expr->getType (), false));
	  }
	  else
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	;
    break;}
case 250:
#line 2825 "parser/maria.y"
{
	  yyvsp[0].expr = ensureExpr (yyvsp[0].expr);
	  if ((yyval.expr = yyvsp[-3].expr) && yyvsp[-5].s && yyvsp[0].expr) {
	    yyvsp[0].expr = CSE (yyvsp[0].expr);
	    if (pnwarnings) {
	      class VariableSet vars;
	      vars.insert (*currentVariables.top ());
	      if (!yyvsp[0].expr->depends (vars, false)) {
		thePrinter.printRaw ("Warning:mapping is independent of ");
		thePrinter.printQuoted (currentVariables.top ()->getName ());
		thePrinter.finish ();
	      }
	    }
	    yyval.expr = CSE (new class Mapping
		      (*currentVariables.top (), NULL, *yyvsp[-3].expr, *yyvsp[0].expr));
	  }
	  else
	    yyvsp[0].expr->destroy ();
	  if (yyvsp[-5].s)
	    currentVariables.pop ();
	;
    break;}
case 251:
#line 2848 "parser/maria.y"
{
	  if (yyvsp[-1].expr && yyvsp[-1].expr->getKind () == Expression::eEmptySet) {
	    pnwarn ("any subset of an empty set is an empty set");
	    delete[] yyvsp[-5].s, yyvsp[-5].s = NULL;
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	  else if ((yyvsp[-1].expr = ensureSet (yyvsp[-1].expr)) && yyvsp[-5].s && yyvsp[-3].s && yyvsp[-1].expr->getType ()) {
	    checkIterator (yyvsp[-5].s); checkIterator (yyvsp[-3].s);
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-5].s, Net::getCardType (), false));
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-3].s, *yyvsp[-1].expr->getType (), false));
	  }
	  else {
	    delete[] yyvsp[-5].s, yyvsp[-5].s = NULL;
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	;
    break;}
case 252:
#line 2867 "parser/maria.y"
{
	  yyvsp[0].expr = ensureCard (yyvsp[0].expr);
	  yyval.expr = yyvsp[-3].expr;
	  if (yyvsp[-7].s && yyvsp[-5].s) {
	    class VariableDefinition* token = currentVariables.top ();
	    currentVariables.pop ();
	    class VariableDefinition* mult = currentVariables.top ();
	    currentVariables.pop ();
	    if (yyval.expr && yyvsp[0].expr) {
	      yyvsp[0].expr = CSE (yyvsp[0].expr);
	      if (pnwarnings) {
		class VariableSet vars;
		vars.insert (*token);
		vars.insert (*mult);
		if (!yyvsp[0].expr->depends (vars, false)) {
		  thePrinter.printRaw ("Warning:mapping depends neither on ");
		  thePrinter.printQuoted (token->getName ());
		  thePrinter.printRaw (" nor ");
		  thePrinter.printQuoted (mult->getName ());
		  thePrinter.finish ();
		}
	      }
	      yyval.expr = CSE (new class Mapping
			(*token, mult, *yyvsp[-3].expr, *yyvsp[0].expr));
	    }
	    else
	      yyvsp[0].expr->destroy ();
	  }
	  else
	    yyvsp[0].expr->destroy ();
	;
    break;}
case 253:
#line 2901 "parser/maria.y"
{
	  if (class Function* f = functionStack.top ()) {
	    if (!f->getArity ())
	      yyval.exprList = new class ExpressionList;
	    else {
	      thePrinter.printRaw ("function ");
	      thePrinter.printQuoted (f->getName ());
	      thePrinter.printRaw (" expects ");
	      thePrinter.print (f->getArity ());
	      thePrinter.printRaw (", not zero arguments");
	      thePrinter.finish ();
	      pnerrors++;
	      yyval.exprList = NULL;
	    }
	  }
	  else
	    yyval.exprList = NULL;
	;
    break;}
case 254:
#line 2920 "parser/maria.y"
{
	  const class Type* type = NULL;

	  if (class Function* f = functionStack.top ()) {
	    if (f->getArity ())
	      type = &(*f)[0].getType ();
	    else {
	      thePrinter.printRaw ("function ");
	      thePrinter.printQuoted (f->getName ());
	      thePrinter.printRaw (" takes no arguments");
	      thePrinter.finish ();
	      pnerrors++;
	    }
	  }

	  pushTypeContext (type);
	;
    break;}
case 255:
#line 2938 "parser/maria.y"
{
	  if (currentType &&
	      isCompatible ((yyvsp[0].expr = noMarking (yyvsp[0].expr)), currentType)) {
	    if (functionStack.top ())
	      (yyval.exprList = new class ExpressionList)->append (*yyvsp[0].expr);
	    else {
	      yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	    }
	  }
	  else {
	    yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	  }
	  popTypeContext ();
	;
    break;}
case 256:
#line 2954 "parser/maria.y"
{
	  const class Type* type = NULL;

	  if (class Function* f = functionStack.top ()) {
	    if (yyvsp[-1].exprList) {
	      if (f->getArity () > yyvsp[-1].exprList->size ())
		type = &(*f)[yyvsp[-1].exprList->size ()].getType ();
	      else {
		thePrinter.printRaw ("function ");
		thePrinter.printQuoted (f->getName ());
		thePrinter.printRaw (" takes only ");
		thePrinter.print (f->getArity ());
		thePrinter.printRaw (" arguments");
		thePrinter.finish ();
		pnerrors++;
	      }
	    }
	  }

	  pushTypeContext (type);
	;
    break;}
case 257:
#line 2976 "parser/maria.y"
{
	  if ((yyval.exprList = yyvsp[-3].exprList) && currentType &&
	      isCompatible ((yyvsp[0].expr = noMarking (yyvsp[0].expr)), currentType)) {
	    if (functionStack.top ())
	      yyval.exprList->append (*yyvsp[0].expr);
	    else {
	      yyval.exprList->destroy (); yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	    }
	  }
	  else {
	    yyval.exprList->destroy (); yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	  }
	  popTypeContext ();
	;
    break;}
case 258:
#line 2992 "parser/maria.y"
{ if ((yyval.exprList = yyvsp[-1].exprList)) pnerror ("extraneous comma in argument list"); ;
    break;}
case 259:
#line 2998 "parser/maria.y"
{
	  if ((yyvsp[0].expr = noMarking (yyvsp[0].expr)))
	    (yyval.exprList = new class ExpressionList)->prepend (*yyvsp[0].expr);
	  else {
	    yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	  }
	;
    break;}
case 260:
#line 3007 "parser/maria.y"
{
	  yyvsp[0].expr = noMarking (yyvsp[0].expr);
	  if ((yyval.exprList = yyvsp[-2].exprList) && yyvsp[0].expr) {
	    if (yyval.exprList->getType () && yyvsp[0].expr->getType () &&
		yyval.exprList->getType () != yyvsp[0].expr->getType ()) {
	      pnerror ("incompatible types in ?: expression");
	      yyval.exprList->destroy (); yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	    }
	    else
	      yyval.exprList->prepend (*yyvsp[0].expr);
	  }
	  else {
	    yyval.exprList->destroy (); yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	  }
	;
    break;}
case 261:
#line 3026 "parser/maria.y"
{ beginQuantifier (yyvsp[0].s, yyvsp[-1].type); ;
    break;}
case 262:
#line 3028 "parser/maria.y"
{ continueQuantifier (ASSERT1 (yyvsp[-3].type)); ;
    break;}
case 263:
#line 3030 "parser/maria.y"
{ yyval.expr = endQuantifier (yyvsp[-5].s, yyvsp[-6].type, yyvsp[-3].expr, yyvsp[-1].i, yyvsp[0].expr, true); ;
    break;}
case 264:
#line 3033 "parser/maria.y"
{ currentContextTransition = yyvsp[-1].trans; ;
    break;}
case 265:
#line 3035 "parser/maria.y"
{
	  yyvsp[0].expr = ensureBool (ensureExpr (yyvsp[0].expr));
	  if (yyvsp[-3].trans && yyvsp[0].expr)
	    yyval.expr = CSE (new class TransitionQualifier (*yyvsp[-3].trans, *CSE (yyvsp[0].expr)));
	  else
	    yyvsp[0].expr->destroy (), yyval.expr = NULL;
	  currentContextTransition = NULL;
	;
    break;}
case 266:
#line 3045 "parser/maria.y"
{
	  yyval.expr = yyvsp[0].trans
	    ? CSE (new class TransitionQualifier
		   (*yyvsp[0].trans,
		    *CSE (new class Constant
			  (*new class LeafValue (Net::getBoolType (), true)))))
	    : NULL;
	;
    break;}
case 267:
#line 3055 "parser/maria.y"
{ yyval.expr = yyvsp[-1].expr; ;
    break;}
case 268:
#line 3058 "parser/maria.y"
{ yyval.expr = newNotExpression (yyvsp[0].expr); ;
    break;}
case 269:
#line 3061 "parser/maria.y"
{
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (true, yyvsp[-2].expr, yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 270:
#line 3070 "parser/maria.y"
{
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (false, yyvsp[-2].expr, yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 271:
#line 3079 "parser/maria.y"
{
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (false, newNotExpression (yyvsp[-2].expr), yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 272:
#line 3088 "parser/maria.y"
{ yyval.expr = newNotExpression (newRelopExpression (true, yyvsp[-2].expr, yyvsp[0].expr)); ;
    break;}
case 273:
#line 3091 "parser/maria.y"
{ yyval.expr = newRelopExpression (true, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
}

#line 727 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 3094 "parser/maria.y"


static void
checkIterator (const char* name)
{
  checkName (name, ckIter, "invalid iterator variable name ");
}

static class Type*
copyType (class Type* type)
{
  if (type->getName () || Net::isPredefinedType (*type)) {
    if (!theNet.hasType (*type)) theNet.addType (*type, 0);
    return type->copy ();
  }
  else
    return type;
}

static void
deleteType (class Type* type)
{
  if (type && !type->getName () && !Net::isPredefinedType (*type) &&
      !theNet.hasType (*type))
    delete type;
}

static void
printType (const class Type& type)
{
  if (const char* name = type.getName ())
    thePrinter.print (name);
  else
    type.display (thePrinter);
}

static void pushTypeContext (const class Type* type)
{
  StructLevel p (currentContextType, currentComponent);
  structLevels.push (p);
  StructLevel q (currentType, 0);
  structLevels.push (q);

  currentType = type;
  currentContextType = NULL, currentComponent = 0;
}

static void popTypeContext ()
{
  StructLevel p = structLevels.top ();
  structLevels.pop ();
  currentType = p.first;
  assert (!p.second);
  p = structLevels.top ();
  structLevels.pop ();
  currentContextType = p.first;
  currentComponent = p.second;
}

static const class VariableDefinition*
getParameter (char* name)
{
  for (unsigned i = 0; i < currentArity; i++) {
    if (!strcmp (currentParameters[i]->getName (), name))
      return currentParameters[i];
  }

  return NULL;
}

static void
addParameter (const class Type* type, char* name)
{
  if (!type || !name) {
    delete[] name;
    return;
  }

  if (getParameter (name)) {
    thePrinter.printRaw ("ignoring redefinition of parameter ");
    thePrinter.printQuoted (name);
    thePrinter.finish ();
    pnerrors++;
    delete[] name;
    return;
  }

  checkName (name, ckParam, "invalid function parameter name ");

  if (pnwarnings) {
    const char* shadow = 0;
    if (currentTransition && currentTransition->getVariable (name))
      shadow = " shadows a variable";
    else if (getConstant (name) || getConstantFunction (name))
      shadow = " shadows a constant";
    else if (theNet.getType (name))
      shadow = " shadows a type name";

    if (shadow) {
      thePrinter.printRaw ("Warning:parameter ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (shadow);
      thePrinter.finish ();
    }
  }

  class VariableDefinition** v =
    new class VariableDefinition*[currentArity + 1];
  assert (!currentArity || currentParameters);
  assert (currentArity || !currentParameters);

  memcpy (v, currentParameters, currentArity * sizeof *v);
  delete[] currentParameters;
  currentParameters = v;
  currentParameters[currentArity++] =
    new class VariableDefinition (name, *type, false);
}

static class Function*
getFunction (const char* name)
{
  class Function* f = currentTransition
    ? currentTransition->getFunction (name)
    : (currentContextTransition
       ? currentContextTransition->getFunction (name)
       : NULL);
  if (!f)
    f = theNet.getFunction (name);
  return f;
}

static class Function*
getConstantFunction (const char* name)
{
  class Function* f = currentTransition
    ? currentTransition->getFunction (name)
    : (currentContextTransition
       ? currentContextTransition->getFunction (name)
       : NULL);
  if (!f || f->getArity ())
    f = theNet.getFunction (name);
  return f && f->getArity () ? NULL : f;
}

static const class Constant*
getConstant (const char* name)
{
  const class Constant* c = currentTransition
    ? currentTransition->getConstant (name)
    : (currentContextTransition
       ? currentContextTransition->getConstant (name)
       : NULL);
  return c ? c : theNet.getConstant (name);
}

static const class VariableDefinition*
getVariable (char* name)
{
  assert (name != NULL);

  const class VariableDefinition* v = getParameter (name);
  const class Function* f = getConstantFunction (name);
  const class Constant* c = getConstant (name);

  if (v || (v = currentVariables.find (name)))
    goto found;

  if (!currentTransition) {
    if (currentContextTransition &&
	(v = currentContextTransition->getVariable (name)));
    else if (!f && !c &&
	     !(currentType && currentType->getKind () == Type::tEnum &&
	       static_cast<const class EnumType*>(currentType)
	       ->getValue (name))) {
      thePrinter.printRaw ("undefined variable ");
      thePrinter.printQuoted (name);
      thePrinter.finish ();
      pnerrors++;
    }
    delete[] name;
  }
  else if ((v = currentTransition->getVariable (name))) {
  found:
    delete[] name;
  }
  else if (f || c)
    delete[] name;
  else if (!currentType) {
    thePrinter.printRaw ("cannot determine the type of variable ");
    thePrinter.printQuoted (name);
    thePrinter.finish ();
    pnerrors++;
    delete[] name;
  }
  else {
    assert (currentType != NULL);

    if (pnwarnings && theNet.getType (name)) {
      thePrinter.printRaw ("Warning:variable ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (" shadows a type name");
      thePrinter.finish ();
    }

    if (currentType->getKind () != Type::tEnum ||
	!static_cast<const class EnumType*>(currentType)->getValue (name)) {
      checkName (name, ckVar, "invalid (implicit) variable name ");
      v = &currentTransition->addVariable (name, *currentType, false, false);
    }
    else
      delete[] name;
  }

  return v;
}

static class Expression*
resolveName (char* name)
{
  const class Constant* c = getConstant (name);
  class Function* f = getConstantFunction (name);
  const card_t*const i =
    (currentType && currentType->getKind () == Type::tEnum)
    ? static_cast<const class EnumType*>(currentType)->getValue (name)
    : NULL;
  if (const class VariableDefinition* d = getVariable (name))
    return static_cast<class Variable*>(CSE (new class Variable (*d)));
  else if (c)
    return CSE (const_cast<class Constant*>(c)->copy ());
  else if (class Expression* expr = f ? f->expand (NULL) : NULL)
    return fold (expr);
  else if (i)
    return enumValue (*static_cast<const class EnumType*>(currentType), *i);
  else
    return NULL;
}

static class Expression*
ensureSet (class Expression* expr,
	   const class Type* type)
{
  return !expr || expr->isSet () ? expr : ensureMarking (expr, type);
}

static class Marking*
ensureMarking (class Expression* expr,
	       const class Type* type,
	       bool temporal)
{
  if (!expr)
    return NULL;
  else if (expr->getKind () == Expression::eUndefined) {
    pnerror ("undefined marking expressions are not allowed");
    expr->destroy ();
    return NULL;
  }

  assert (expr->getType () || expr->getKind () == Expression::eEmptySet);

  if (expr->getKind () == Expression::eMarking)
    return static_cast<class Marking*>(expr);
  else if (expr->isSet () || expr->isBasic ()) {
    if (currentPlace) {
      if (!type)
	type = &currentPlace->getType ();
      if (!makeCompatible (expr, *type)) {
	pnerror ("marking expression has incompatible type");
	return NULL;
      }
    }

    if (!type || makeCompatible (expr, *type)) {
      class Marking* m = new class Marking (type ? 0 : currentPlace);
      m->setToken (expr);
      return m;
    }
    else
      return NULL;
  }
  else if (temporal) {
    class Marking* m = new class Marking (currentPlace);
    m->setToken (expr);
    return m;
  }
  else {
    pnerror ("marking expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
noMarking (class Expression* expr)
{
  if (expr && expr->getKind () == Expression::eMarking) {
    pnerror ("marking expression not allowed here");
    expr->destroy ();
    return NULL;
  }

  return expr;
}

static class Expression*
ensureExpr (class Expression* expr)
{
  expr = noMarking (expr);

  if (expr && !expr->isBasic ()) {
    pnerror ("basic expression expected");
    expr->destroy (); return NULL;
  }

  return expr;
}

static class Expression*
ensureBool (class Expression* expr, bool undefined)
{
  expr = noMarking (expr);

  if (!expr)
    return NULL;

  if (expr->getKind () == Expression::eUndefined) {
    if (undefined)
      return expr;
    pnerror ("undefined or fatal expression is not meaningful here");
    expr->destroy (); return NULL;
  }

  if (!expr->getType ()) {
    pnerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  if (expr->getType ()->getKind () != Type::tBool) {
    pnerror ("boolean expression expected");
    expr->destroy (); return NULL;
  }

  return expr;
}

static class Expression*
ensureInt (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    pnerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  switch (expr->getType ()->getKind ()) {
  case Type::tInt:
    return expr;
  case Type::tEnum:
  case Type::tChar:
  case Type::tCard:
  case Type::tBool:
    if (!makeCompatible (expr, Net::getIntType (), true));
    else if (expr->getType () == &Net::getIntType ())
      return expr;
    /* fall through */
  default:
    pnerror ("signed integer expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
ensureCard (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    pnerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  switch (expr->getType ()->getKind ()) {
  case Type::tCard:
    return expr;
  case Type::tEnum:
  case Type::tChar:
  case Type::tInt:
  case Type::tBool:
    if (!makeCompatible (expr, Net::getCardType (), true));
    else if (expr->getType () == &Net::getCardType ())
      return expr;
    /* fall through */
  default:
    pnerror ("unsigned integer expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
ensureIntCard (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    pnerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  switch (expr->getType ()->getKind ()) {
  case Type::tCard:
  case Type::tInt:
    return expr;
  case Type::tEnum:
  case Type::tChar:
  case Type::tBool:
    if (!makeCompatible (expr, Net::getCardType (), true));
    else if (expr->getType () == &Net::getCardType () ||
	     expr->getType () == &Net::getIntType ())
      return expr;
    /* fall through */
  default:
    pnerror ("integer expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
ensureBuffer (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    pnerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  if (expr->getType ()->getKind () != Type::tBuffer) {
    pnerror ("buffer expression expected");
    expr->destroy (); return NULL;
  }

  return expr;
}

static class Expression*
ensureOrdered (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    pnerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  if (!isOrdered (*expr->getType ())) {
    expr->destroy (); return NULL;
  }

  return expr;
}

static void
addEnumeration (class EnumType* e, char* name)
{
  assert (e && name);
  const card_t* const i = e->getValue (name);
  if (i) {
    thePrinter.printRaw ("enumeration constant ");
    thePrinter.printQuoted (name);
    thePrinter.printRaw (" already defined as ");
    thePrinter.print (*i);
    thePrinter.finish ();
    pnerrors++;
    delete[] name;
  }
  else
    e->addEnumeration (name);
  if (pnwarnings) {
    if (getConstant (name)) {
      thePrinter.printRaw ("Warning:enumeration constant ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (" shadows a constant");
      thePrinter.finish ();
    }
    else if (theNet.getType (name)) {
      thePrinter.printRaw ("Warning:enumeration constant ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (" shadows a type name");
      thePrinter.finish ();
    }
  }
}

static void
addEnumeration (class EnumType* e, char* name, card_t value)
{
  assert (e && name);
  const card_t* const i = e->getValue (name);
  if (e->getValue (name)) {
    thePrinter.printRaw ("enumeration constant ");
    thePrinter.printQuoted (name);
    thePrinter.printRaw (" already defined as ");
    thePrinter.print (*i);
    thePrinter.finish ();
    pnerrors++;
    delete[] name;
  }
  else if (e->hasValue (value)) {
    thePrinter.printRaw ("enumeration already contains the value ");
    thePrinter.print (value);
    thePrinter.finish ();
    pnerrors++;
    delete[] name;
  }
  else
    e->addEnumeration (name, value);
  if (pnwarnings) {
    if (getConstant (name)) {
      thePrinter.printRaw ("Warning:enumeration constant ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (" shadows a constant");
      thePrinter.finish ();
    }
    else if (theNet.getType (name)) {
      thePrinter.printRaw ("Warning:enumeration constant ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (" shadows a type name");
      thePrinter.finish ();
    }
  }
}

static class Value*
ensureConstant (class Expression* expr, const class Type* type)
{
  if (!(expr = fold (expr)))
    return NULL;

  if (!type) {
    expr->destroy ();
    return NULL;
  }

  if (!isOrdered (*type)) {
    expr->destroy ();
    return NULL;
  }

  class Value* v = NULL;
  if (expr->getKind () == Expression::eConstant) {
    const class Valuation empty;
    v = expr->eval (empty);
    assert (!!v);
  }
  else
    pnerror ("constant expected");

  expr->destroy ();

  switch (type->getKind ()) {
  case Type::tInt:
  case Type::tCard:
  case Type::tBool:
  case Type::tChar:
  case Type::tEnum:
    break;
  default:
    if (&v->getType () == type)
      return v;
    thePrinter.printRaw ("unable to convert constant from ");
    printType (v->getType ());
    thePrinter.printRaw (" to ");
    printType (*type);
    thePrinter.finish ();
    pnerrors++;
    delete v;
    return NULL;
  }

  /** the integer value */
  struct {
    /** tag: is the value unsigned */
    bool u;
    /** the actual value */
    union {
      int_t i; ///< signed
      card_t u; ///< unsigned
    } v;
  } value;

  switch (v->getType ().getKind ()) {
  case Type::tInt:
    assert (v->getKind () == Value::vLeaf);
    if (&v->getType () == type)
      return v;
    value.u = false, value.v.i = int_t (static_cast<class LeafValue&>(*v));
    break;
  case Type::tCard:
    assert (v->getKind () == Value::vLeaf);
    if (&v->getType () == type)
      return v;
    value.u = true, value.v.u = card_t (static_cast<class LeafValue&>(*v));
    break;
  case Type::tBool:
    assert (v->getKind () == Value::vLeaf);
    if (&v->getType () == type)
      return v;
    value.u = true, value.v.u = bool (static_cast<class LeafValue&>(*v));
    break;
  case Type::tChar:
    assert (v->getKind () == Value::vLeaf);
    if (&v->getType () == type)
      return v;
    value.u = false, value.v.i = int_t (static_cast<class LeafValue&>(*v));
    break;
  case Type::tEnum:
    assert (v->getKind () == Value::vLeaf);
    if (&v->getType () == type)
      return v;
    value.u = true, value.v.u = card_t (static_cast<class LeafValue&>(*v));
    break;

  default:
    if (&v->getType () == type)
      return v;
    thePrinter.printRaw ("cannot define constraint: incompatible type ");
    printType (v->getType ());
    thePrinter.finish ();
    pnerrors++;
    delete v;
    return NULL;
  }

  if (pnwarnings && v->getType ().getKind () != type->getKind () &&
      !((type->getKind () == Type::tInt || type->getKind () == Type::tCard) &&
	(v->getType ().getKind () == Type::tInt ||
	 v->getType ().getKind () == Type::tCard))) {
    thePrinter.printRaw ("Warning:converting constant ");
    thePrinter.print (value.u ? value.v.u : value.v.i);
    thePrinter.printRaw (" from ");
    printType (v->getType ());
    thePrinter.printRaw (" to ");
    printType (*type);
    thePrinter.finish ();
  }

  delete v;
  v = NULL;
  switch (type->getKind ()) {
  case Type::tInt:
    if (value.u) {
      if (value.v.u > INT_T_MAX)
	break;
      value.v.i = value.v.u, value.u = false;
    }
    if (type->isConstrained (*(v = new class LeafValue (*type, value.v.i))))
      return v;
    delete v;
    break;
  case Type::tCard:
    if (!value.u) {
      if (value.v.i < 0)
	break;
      value.v.u = value.v.i, value.u = true;
    }
    if (type->isConstrained (*(v = new class LeafValue (*type, value.v.u))))
      return v;
    delete v;
    break;
  case Type::tBool:
    if (value.u) {
      if ((value.v.u == 0 || value.v.u == 1) &&
	  type->isConstrained (*(v = new class LeafValue (*type,
							  value.v.u == 1))))
	return v;
    }
    else {
      if ((value.v.i == 0 || value.v.i == 1) &&
	  type->isConstrained (*(v = new class LeafValue (*type,
							  value.v.i == 1))))
	return v;
    }
    delete v;
    break;
  case Type::tChar:
    if (!value.u) {
      if (value.v.i < 0)
	break;
      value.v.u = value.v.i, value.u = true;
    }
    if (value.v.u <= CHAR_T_MAX &&
	type->isConstrained (*(v = new class LeafValue (*type, value.v.u))))
      return v;
    delete v;
    break;
  case Type::tEnum:
    if (!value.u) {
      if (value.v.i < 0)
	break;
      value.v.u = value.v.i, value.u = true;
    }
    if (type->isConstrained (*(v = new class LeafValue (*type, value.v.u))) ||
	!type->getConstraint ())
      return v;
    delete v;
    break;

  default:
    assert (false);
  }

  thePrinter.printRaw ("value ");
  thePrinter.print (value.u ? value.v.u : value.v.i);
  thePrinter.printRaw (" out of range for type ");
  printType (*type);
  thePrinter.finish ();
  pnerrors++;
  return NULL;
}

static class Expression*
enumValue (const class EnumType& type, card_t value)
{
  class LeafValue* e = new class LeafValue (type, value);
  if (type.isConstrained (*e))
    return CSE (new class Constant (*e));
  else {
    thePrinter.printRaw ("enumeration constant ");
    if (const char* c = type.getEnumName (value)) {
      thePrinter.print (c);
      thePrinter.delimiter ('=');
    }
    thePrinter.print (value);
    thePrinter.printRaw (" out of range for type ");
    printType (type);
    thePrinter.finish ();
    pnerrors++;
    delete e;
    return NULL;
  }
}

static class Expression*
namedComponent (char* name, class Expression* expr)
{
  if (!name) {
    expr->destroy ();
    return NULL;
  }

  if (!currentContextType || currentContextType->getKind () != Type::tStruct) {
    thePrinter.printRaw ("named component ");
    thePrinter.printQuoted (name);
    thePrinter.printRaw (" can only be used with a struct");
    thePrinter.finish ();
    pnerrors++;
    expr->destroy ();
    delete[] name;
    return NULL;
  }

  const class StructType& type =
    static_cast<const class StructType&>(*currentContextType);

  if (currentComponent < type.getSize ()) {
    const char* comp = type.getComponentName (currentComponent);
    if (strcmp (name, comp)) {
      thePrinter.printRaw ("expecting named component ");
      thePrinter.printQuoted (comp);
      thePrinter.printRaw (" instead of ");
      thePrinter.printQuoted (name);
      thePrinter.finish ();
      pnerrors++;
      expr->destroy ();
      delete[] name;
      return NULL;
    }
  }
  else {
    thePrinter.printRaw ("extraneous named component ");
    thePrinter.printQuoted (name);
    thePrinter.printRaw (" at end of struct");
    thePrinter.finish ();
    pnerrors++;
    expr->destroy ();
    delete[] name;
    return NULL;
  }

  delete[] name;
  return expr;
}

static void
beginAny (class Type*& type, char* name,
	  bool hidden)
{
  if (type) {
    if (currentTransition) {
      if (name && currentTransition->getVariable (name)) {
	thePrinter.printRaw ("output variable ");
	thePrinter.printQuoted (name);
	thePrinter.printRaw (" shadows another variable");
	thePrinter.finish ();
	pnerrors++;
	type = NULL; delete[] name;
      }
      else if (name) {
	checkIterator (name);
	currentTransition->addVariable (name, *type, true, hidden);
      }
      card_t size = type->getNumValues ();
      if (!size || size == CARD_T_MAX || (maxRange && size > maxRange)) {
	thePrinter.printRaw ("type ");
	printType (*type);
	thePrinter.printRaw (" has too many (");
	thePrinter.print (size);
	thePrinter.printRaw (") values for non-determinism");
	if (size && size < CARD_T_MAX)
	  thePrinter.printRaw (" (try -q0)");
	thePrinter.finish ();
	pnerrors++;
      }
    }
    else {
      pnerror ("non-determinism is only allowed on output arcs");
      type = NULL; delete[] name;
    }
  }
  else
    delete[] name;

  pushTypeContext (type);
}

static class Variable*
endAny (const class Type* type,
	char* name,
	class Expression* condition)
{
  class Variable* var;
  popTypeContext ();

  if (type) {
    if (!condition || (condition = ensureBool (ensureExpr (condition)))) {
      var = static_cast<class Variable*>
	(CSE (new class Variable
	      (currentTransition->addOutputVariable (*type, name,
						     condition))));
      assert (var != NULL);
      if (pnwarnings && condition) {
	class VariableSet vars;
	vars.insert (var->getVariable ());
	if (!condition->depends (vars, false)) {
	  thePrinter.printRaw ("Warning:condition is independent of ");
	  thePrinter.printQuoted (var->getVariable ().getName ());
	  thePrinter.finish ();
        }
      }
    }
    else
      var = NULL, condition->destroy ();
  }
  else
    var = NULL, condition->destroy ();
  return var;
}

static void
beginQuantifier (char* name, const class Type* type)
{
  if (name && type) {
    checkIterator (name);
    if (pnwarnings) {
      const char* shadow = 0;
      if (currentVariables.find (name))
        shadow = " shadows another quantifier";
      else if ((currentTransition &&
		currentTransition->getVariable (name)) ||
	       (currentContextTransition &&
		currentContextTransition->getVariable (name)))
	shadow = " shadows a transition variable";
      else if (getConstant (name))
	shadow = " shadows a constant";
      else if (currentType && currentType->getKind () == Type::tEnum &&
	       static_cast<const class EnumType*>(currentType)->
	       getValue (name))
	shadow = " shadows an enumeration constant";
      else if (theNet.getType (name))
	shadow = " shadows a type name";

      if (shadow) {
	thePrinter.printRaw ("quantifier ");
	thePrinter.printQuoted (name);
	thePrinter.printRaw (shadow);
	thePrinter.finish ();
      }
    }

    card_t size = type->getNumValues ();
    if (!size || size == CARD_T_MAX || (maxRange && size > maxRange)) {
      thePrinter.printRaw ("type ");
      printType (*type);
      thePrinter.printRaw (" has too many (");
      thePrinter.print (size);
      thePrinter.printRaw (") values for quantification");
      if (size && size < CARD_T_MAX)
	thePrinter.printRaw (" (try -q0)");
      thePrinter.finish ();
      pnerrors++;
    }
    currentVariables.push (new class VariableDefinition (name, *type, true));
  }

  struct TypeContext tc = {
    currentContextType,
    currentType,
    currentComponent
  };
  typeStack.push (tc);

  currentContextType = NULL;
  currentComponent = 0;
  currentType = type;
}

static void
continueQuantifier (ASSERT1 (const class Type* type))
{
  assert (!currentContextType);
  assert (currentType == type);
  assert (!typeStack.empty ());
  struct TypeContext tc = typeStack.top ();
  typeStack.pop ();

  currentContextType = tc.context;
  currentType = tc.component;
  currentComponent = tc.numComponent;
}

static class Expression*
endQuantifier (char* name,
	       const class Type* type,
	       class Expression* condition,
	       unsigned kind,
	       class Expression* expr,
	       bool temporal)
{
  if (name && type && expr && kind) {
    class VariableDefinition* var = currentVariables.top ();
    currentVariables.pop ();

    card_t size = var->getType ().getNumValues ();
    if (!size || size == CARD_T_MAX || (maxRange && size > maxRange)) {
      condition->destroy ();
      expr->destroy ();
      delete var;
      return NULL;
    }

    if ((condition = ensureBool (ensureExpr (condition))) && pnwarnings) {
      class VariableSet vars;
      vars.insert (*var);
      if (!condition->depends (vars, false)) {
	thePrinter.printRaw ("Warning:condition is independent of ");
	thePrinter.printQuoted (var->getName ());
	thePrinter.finish ();
      }
    }

    class Valuation v;
    switch (kind) {
    case 1:
      if (class Marking* m = ensureMarking (expr, currentType, temporal)) {
	expr = m->quantify (v,
			    currentTransition
			    ? currentTransition
			    : currentContextTransition,
			    *var, condition,
			    currentTransition && !temporal);
	m->destroy ();
	delete var;
	if (!expr) {
	  if (check (v))
	    pnerror ("conflicting variables in quantification");
	}
	else
	  assert (v.isOK ());
	return CSE (expr);
      }
      else
	expr = NULL;
      break;
    case 2:
    case 3:
      if ((expr = ensureBool (expr))) {
	class Expression* e =
	  BooleanBinop::quantify (kind != 2,
				  *expr, v,
				  currentTransition
				  ? currentTransition
				  : currentContextTransition,
				  *var, condition,
				  currentTransition && !temporal);
	expr->destroy ();
	delete var;
	if (!e) {
	  if (check (v))
	    pnerror ("conflicting variables in quantification");
	}
	else
	  assert (v.isOK ());
	return CSE (e);
      }
      break;
    default:
      assert (false);
    }

    expr->destroy ();
    delete var;
    return NULL;
  }
  else {
    condition->destroy (), expr->destroy ();
    if (name && type) {
      class VariableDefinition* var = currentVariables.top ();
      currentVariables.pop ();
      delete var;
    }
    else
      delete[] name;
    return NULL;
  }
}

static class Expression*
quantifierVariable (char* prefix, char* quant, bool pred)
{
  char p = pred ? ',' : '.';
  if (!prefix) {
    delete[] prefix;
    delete[] quant;
    return NULL;
  }
  class VariableDefinition* var;
  if (currentVariables.empty ())
    var = NULL;
  else if (quant)
    var = currentVariables.find (quant);
  else
    var = currentVariables.top ();

  if (!var) {
    thePrinter.delimiter (p);
    thePrinter.print (prefix);
    if (quant) {
      thePrinter.printRaw (": quantifier ");
      thePrinter.print (quant);
      thePrinter.printRaw (" not found");
    }
    else
      thePrinter.printRaw (": no quantifier found");
    thePrinter.finish ();
    pnerrors++;
  }
  else if (!var->isAggregate ()) {
    thePrinter.delimiter (p);
    thePrinter.print (prefix);
    thePrinter.printRaw (": variable ");
    thePrinter.print (var->getName ());
    thePrinter.printRaw (" is not a quantifier");
    thePrinter.finish ();
    pnerrors++;
  }
  else if (!currentTransition && !currentContextTransition) {
    thePrinter.printRaw ("quantifier ");
    thePrinter.print (var->getName ());
    thePrinter.printRaw (": cannot define ");
    thePrinter.delimiter (p);
    thePrinter.print (prefix);
    thePrinter.printRaw (" outside transition");
    thePrinter.finish ();
    pnerrors++;
  }
  else if (!currentType) {
    if (const class VariableDefinition* qvar = var->findChild (prefix)) {
      delete[] quant;
      delete[] prefix;
      return CSE (new class Variable (*qvar, pred));
    }
    else {
      thePrinter.printRaw ("quantifier ");
      thePrinter.print (var->getName ());
      thePrinter.printRaw (": cannot determine the type of ");
      thePrinter.delimiter (p);
      thePrinter.print (prefix);
      thePrinter.finish ();
      pnerrors++;
    }
  }
  else if (const class VariableDefinition* qvar =
	   var->addChild (prefix, *currentType)) {
    delete[] quant;
    return CSE (new class Variable (*qvar, pred));
  }
  else {
    thePrinter.printRaw ("quantifier ");
    thePrinter.print (var->getName ());
    thePrinter.printRaw (": contradictory type for ");
    thePrinter.delimiter (p);
    thePrinter.print (prefix);
    thePrinter.finish ();
    pnerrors++;
  }

  delete[] prefix;
  delete[] quant;
  return NULL;
}

static bool
makeCompatible (class Expression*& expr,
		const class Type& type,
		bool casting)
{
  if (!expr) return false;
  if (expr->getType () == &type ||
      expr->getKind () == Expression::eEmptySet)
    return true;
  assert (!!expr->getType ());
  const class Type& srcType = *expr->getType ();
  if (((Typecast::isCastable (type) &&
	Typecast::isCastable (srcType)) ||
       Type::isCompatible (srcType, type)) &&
      expr->isBasic () && !expr->isSet ()) {
    bool isConstant = expr->getKind () == Expression::eConstant;
    expr = CSE (new class Typecast (type, *expr));
    if (!casting && pnwarnings &&
	((!srcType.isAssignable (type) &&
	  srcType.getKind () != Type::tCard &&
	  srcType.getKind () != Type::tInt &&
	  type.getKind () != Type::tCard &&
	  type.getKind () != Type::tInt) ||
	 (!isConstant && !srcType.isAlwaysAssignable (type)))) {
      thePrinter.printRaw ("Warning:implicit conversion from ");
      printType (srcType);
      thePrinter.printRaw (" to ");
      printType (type);
      thePrinter.finish ();
    }
    if (isConstant && !(expr = fold (expr))) {
      thePrinter.printRaw ("cannot convert constant from ");
      printType (srcType);
      thePrinter.printRaw (" to ");
      printType (type);
      thePrinter.finish ();
      pnerrors++;
      return false;
    }
    return true;
  }
  else {
    thePrinter.printRaw ("cannot convert from ");
    printType (srcType);
    thePrinter.printRaw (" to ");
    printType (type);
    thePrinter.finish ();
    pnerrors++;
    return false;
  }
}

static bool
isCompatible (class Expression*& expr,
	      const class Type* type)
{
  if (!type) {
    pnerror ("too many components for struct");
    return false;
  }

  if (!expr)
    return false;

  if (!expr->getType ()) {
    pnerror ("expression has no type");
    return false;
  }

  return makeCompatible (expr, *type);
}

static bool
isCompatible (class Expression*& expr,
	      const class StructExpression& s)
{
  const class Type* type = s.getNextType ();
  const char* structName = s.getType ()->getName ();

  if (!type) {
    if (structName) {
      thePrinter.printRaw ("too many components for struct ");
      thePrinter.printQuoted (structName);
    }
    else
      thePrinter.printRaw ("too many components for struct");
    thePrinter.finish ();
    pnerrors++;
    return false;
  }

  const char* comp =
    static_cast<const class StructType*>(s.getType ())
    ->getComponentName (s.size ());

  if (!expr) {
    if (structName) {
      thePrinter.printRaw ("error in expression for struct ");
      thePrinter.printQuoted (structName);
      thePrinter.printRaw (" component ");
    }
    else
      thePrinter.printRaw ("error in expression for struct component ");
    thePrinter.printQuoted (comp);
    thePrinter.finish ();
    pnerrors++;
    return false;
  }

  if (!expr->getType ()) {
    if (structName) {
      thePrinter.printRaw ("expression for struct ");
      thePrinter.printQuoted (structName);
      thePrinter.printRaw (" component ");
    }
    else
      thePrinter.printRaw ("expression for struct component ");
    thePrinter.printQuoted (comp);
    thePrinter.printRaw (" has no type");
    thePrinter.finish ();
    pnerrors++;
    return false;
  }

  if (!makeCompatible (expr, *type))
    return false;

  if (!expr->getType ()->isAlwaysAssignable (*type)) {
    if (Type::isCompatible (*expr->getType (), *type))
      thePrinter.printRaw ("too broad type for struct ");
    else
      thePrinter.printRaw ("type mismatch for struct ");
    if (structName) {
      thePrinter.printQuoted (structName);
      thePrinter.printRaw (" component ");
    }
    else
      thePrinter.printRaw ("component ");
    thePrinter.printQuoted (comp);
    thePrinter.finish ();
    pnerrors++;
    return false;
  }
  else if (expr->getType () != type)
    expr = CSE (new class Typecast (*type, *expr));

  return true;
}

static bool
isOrdered (const class Type& type)
{
  if (!type.isOrdered ()) {
    thePrinter.printRaw ("unordered type ");
    printType (type);
    thePrinter.finish ();
    pnerrors++;
    return false;
  }

  return true;
}

static bool
check (const class Valuation& v)
{
  bool ok = true;

  switch (v.getError ()) {
  case errDiv0:
    ok = false, pnerror ("division by zero"); break;
  case errOver:
    ok = false, pnerror ("overflow"); break;
  case errMod:
    ok = false, pnerror ("modulus error"); break;
  case errShift:
    ok = false, pnerror ("shift error"); break;
  case errConst:
    ok = false, pnerror ("constraint violation"); break;
  case errUnion:
    ok = false, pnerror ("union violation"); break;
  case errBuf:
    ok = false, pnerror ("buffer violation"); break;
  case errCard:
    ok = false, pnerror ("cardinality overflow"); break;
  case errComp:
    assert (false);
  case errNone:
  case errVar:
  case errUndef:
  case errFatal:
    break;
  }

  return ok;
}

static class Expression*
fold (class Expression* expr)
{
  if (expr && expr->isBasic ()) {
    class Valuation v;
    if (class Value* value = expr->eval (v)) {
      assert (v.isOK ());
      expr->destroy ();
      return CSE (new class Constant (*value));
    }
    else {
      if (!check (v)) {
	expr->destroy ();
	return NULL;
      }
      else {
	if (v.getError () == errFatal) {
	  expr->destroy ();
	  return CSE (new class Undefined (Undefined::fFatalError));
	}
	if (v.getError () == errUndef) {
	  expr->destroy ();
	  return CSE (new class Undefined (Undefined::fError));
	}

	assert (v.getError () == errVar);
	return CSE (expr);
      }
    }
  }
  else
    return CSE (expr);
}

static void
defun (const class Type* type,
       char* name,
       class Expression* expr)
{
  currentType = NULL;
  if (!currentArity && type && !type->isLeaf () && name && expr &&
      expr->getKind () == Expression::eConstant) {
    if (isCompatible (expr, type)) {
      if (currentTransition) {
	if (!currentTransition->addConstant
	    (name, *static_cast<class Constant*>(expr))) {
	redef:
	  thePrinter.printRaw ("ignoring redefinition of constant ");
	  thePrinter.printQuoted (name);
	  thePrinter.finish ();
	  pnerrors++;
	  delete[] name, expr->destroy ();
	}
	else if (pnwarnings && theNet.getConstant (name)) {
	  thePrinter.printRaw ("Warning:definition of constant ");
	  thePrinter.printQuoted (name);
	  thePrinter.printRaw (" shadows the global definition");
	  thePrinter.finish ();
	}
      }
      else if (!theNet.addConstant
	       (name, *static_cast<class Constant*>(expr)))
	goto redef;
    }
  }
  else if (type && name && expr) {
    if ((currentTransition && currentTransition->getFunction (name)) ||
	(!currentTransition && theNet.getFunction (name))) {
      thePrinter.printRaw ("ignoring redefinition of function ");
      thePrinter.printQuoted (name);
      thePrinter.finish ();
      pnerrors++;
      delete[] name, expr->destroy ();
    }
    else if (isCompatible (expr, type)) {
      class Function* f =
	new class Function (name, currentArity, currentParameters, expr);
      if (currentTransition) {
	currentTransition->addFunction (*f);
	if (pnwarnings && theNet.getFunction (name)) {
	  thePrinter.printRaw ("Warning:definition of function ");
	  thePrinter.printQuoted (name);
	  thePrinter.printRaw (" shadows the global definition");
	  thePrinter.finish ();
	}
      }
      else
	theNet.addFunction (*f);

      if (pnwarnings && theNet.getType (name)) {
	thePrinter.printRaw ("Warning:function ");
	thePrinter.printQuoted (name);
	thePrinter.printRaw (" shadows a type name");
	thePrinter.finish ();
	for (unsigned i = 0; i < currentArity; i++) {
	  class VariableSet vars;
	  vars.insert (*currentParameters[i]);
	  if (!expr->depends (vars, false)) {
	    thePrinter.printRaw ("Warning:function ");
	    thePrinter.printQuoted (name);
	    thePrinter.printRaw (" does not use parameter ");
	    thePrinter.printQuoted (currentParameters[i]->getName ());
	    thePrinter.finish ();
	  }
	}
      }
    }
    else
      delete[] name, expr->destroy ();
  }
  else
    delete[] name, expr->destroy ();
  currentArity = 0, currentParameters = 0;
  emptyParsed = false;
}

static class Expression*
newRelopExpression (bool equal,
		    class Expression* left,
		    class Expression* right)
{
  left = ensureExpr (left); right = ensureExpr (right);
  if (!left || !right);
  else if (left->getType () != right->getType ()) {
    if (left->getKind () == Expression::eConstant &&
	makeCompatible (left, *right->getType ()))
      goto ok;
    if (right->getKind () == Expression::eConstant &&
	makeCompatible (right, *left->getType ()))
      goto ok;
    pnerror ("expressions in comparison have different types");
  }
  else if (!left->getType ()->isOrdered () && !equal)
    pnerror ("cannot compare expressions of unordered type");
  else {
  ok:
    return fold (RelopExpression::construct (equal, *left, *right));
  }

  left->destroy ();
  right->destroy ();
  return 0;
}

static class Expression*
newBinopExpression (enum BinopExpression::Op op,
		    class Expression* left,
		    class Expression* right)
{
  if (left && left->getType () &&
      left->getType ()->getKind () == Type::tVector) {
    bool shl = false;
    switch (op) {
    case BinopExpression::bRol:
      shl = true;
      break;
    case BinopExpression::bRor:
      shl = false;
      break;
    default:
      ensureIntCard (left)->destroy ();
      ensureIntCard (right)->destroy ();
      return NULL;
    }
    if ((left = ensureExpr (left)) && (right = ensureCard (right))) {
      size_t size =
	static_cast<const class VectorType*>(left->getType ())->getSize ();

      if (shl ||
	  (right = fold (new class BinopExpression
			  (BinopExpression::bMinus,
			   *new class Constant (*new class LeafValue
						(Net::getCardType (),
						 card_t (size))), *right)))) {
	if (right->getKind () == Expression::eConstant) {
	  const class Value& v =
	    static_cast<class Constant*>(right)->getValue ();
	  assert (v.getKind () == Value::vLeaf);
	  card_t amount = static_cast<const class LeafValue&>(v);
	  if (!(amount %= size)) {
	    right->destroy ();
	    return left;
	  }
	}
	return fold (new class VectorShift (*left, *right));
      }
    }
    left->destroy (), right->destroy ();
    return NULL;
  }

  left = ensureIntCard (left);
  right = ensureIntCard (right);
  if (!left || !right) {
    left->destroy (), right->destroy ();
    return NULL;
  }

  if (!(right = left->getType ()->getKind () == Type::tCard
	? ensureCard (right) : ensureInt (right))) {
    left->destroy ();
    return NULL;
  }

  return fold (new class BinopExpression (op, *left, *right));
}

static class Expression*
newNotExpression (class Expression* expr)
{
  if ((expr = ensureBool (expr)))
    expr = fold (NotExpression::construct (*expr));
  return expr;
}

static class Expression*
newBooleanBinop (bool conj,
		 class Expression* left,
		 class Expression* right)
{
  assert (left && right);
  assert (left->getKind () == Expression::eUndefined ||
	  (left->getType () && left->getType ()->getKind () == Type::tBool));
  assert (right->getKind () == Expression::eUndefined ||
	  (right->getType () && right->getType ()->getKind () == Type::tBool));
  const class Value* v;
  bool value;
  assert (left == CSE (left));
  assert (right == CSE (right));

  if (left->getKind () == Expression::eConstant) {
    v = &static_cast<class Constant*>(left)->getValue ();
    left->destroy ();
    assert (v && v->getKind () == Value::vLeaf);
    value = bool (static_cast<const class LeafValue&>(*v));

    if (conj) {
      if (value)
	return right;
      else {
	right->destroy ();
      False:
	pnwarn ("subexpression is always false");
	return CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), false)));
      }
    }
    else {
      if (value) {
	right->destroy ();
      True:
	pnwarn ("subexpression is always true");
	return CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), true)));
      }
      else
	return right;
    }
  }
  else if (right->getKind () == Expression::eConstant) {
    v = &static_cast<class Constant*>(right)->getValue ();
    right->destroy ();
    assert (v && v->getKind () == Value::vLeaf);
    value = bool (static_cast<const class LeafValue&>(*v));

    if (conj) {
      if (value)
	return left;
      else {
	left->destroy ();
	goto False;
      }
    }
    else {
      if (value) {
	left->destroy ();
	goto True;
      }
      else
	return left;
    }
  }
  else
    return CSE (BooleanBinop::construct (conj, *left, *right));

  assert (false);
  return NULL;
}

static class Expression*
newSetExpression (enum SetExpression::Op op,
		  class Expression* left,
		  class Expression* right)
{
  const class Type* type = 0;
  if (right && right->isSet ())
    type = right->getType ();
  else if (left && left->isSet ())
    type = left->getType ();
  left = ensureSet (left, type);
  right = ensureSet (right, type);
  if (!left || !right) {
    left->destroy (), right->destroy ();
    return NULL;
  }

  if (left->getKind () == Expression::eEmptySet) {
    if (right->getKind () == Expression::eEmptySet) {
    Same:
      switch (op) {
      case SetExpression::sIntersection:
      case SetExpression::sMinus:
      case SetExpression::sUnion:
	right->destroy ();
	return left;
      case SetExpression::sSubset:
      case SetExpression::sEquals:
      True:
	left->destroy (), right->destroy ();
	return CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), true)));
      }
      assert (false);
    }
    else {
      assert (!!right->getType ());
      switch (op) {
      case SetExpression::sIntersection:
      case SetExpression::sMinus:
	right->destroy ();
	return left;
      case SetExpression::sUnion:
	left->destroy ();
	return right;
      case SetExpression::sSubset:
	goto True;
      case SetExpression::sEquals:
	goto Compatible;
      }
    }
  }
  else if (right->getKind () == Expression::eEmptySet) {
    switch (op) {
    case SetExpression::sIntersection:
      left->destroy ();
      return right;
    case SetExpression::sMinus:
    case SetExpression::sUnion:
      right->destroy ();
      return left;
    case SetExpression::sSubset:
      op = SetExpression::sEquals;
    case SetExpression::sEquals:
      { class Expression* e = left; left = right; right = e; }
      goto Compatible;
    }
  }

  if (left == right)
    goto Same;

  if (left->getType () == right->getType ()) {
  Compatible:
    return CSE (new class SetExpression (op, *left, *right));
  }
  else {
    pnerror ("expressions have incompatible types");
    left->destroy (), right->destroy ();
    return NULL;
  }
}

static class Expression*
newCardinalityExpression (enum CardinalityExpression::Op op,
			  class Expression* expr)
{
  if (class Expression* m = ensureSet (expr)) {
    if (m->getKind () == Expression::eEmptySet) {
      m->destroy ();
      pnwarn ("the cardinality of an empty set is always zero");
      return CSE (new class Constant (*new class LeafValue
				      (Net::getCardType (),
				       op == CardinalityExpression::cMin
				       ? CARD_T_MAX
				       : 0)));
    }
    else
      return CSE (new class CardinalityExpression (op, *m));
  }
  else
    return NULL;
}

static class Expression*
newBufferUnop (enum BufferUnop::Op op, class Expression* expr)
{
  if (!(expr = ensureBuffer (expr)))
    return NULL;

  if (expr->getKind () == Expression::eBufferIndex) {
    class BufferIndex* b = static_cast<class BufferIndex*>(expr);
    class Expression* buffer = &b->getBuffer ();
    class Expression* index = &b->getIndex ();
    b->destroy ();
    switch (op) {
    case BufferUnop::bFree:
    case BufferUnop::bUsed:
      if (index) {
	pnwarn ("ignoring meaningless buffer indexing expression");
	index->destroy (), index = NULL;
      }
      break;
    case BufferUnop::bPeek:
      break;
    }

    return fold (new class BufferUnop (op, *buffer, index));
  }

  return fold (new class BufferUnop (op, *expr, NULL));
}
